CategoryListBox = class( Turbine.UI.Control );
function CategoryListBox:Constructor(items, name, parent)
	Turbine.UI.Control.Constructor( self );

	self.parent = parent
	self.width = 35 * 5
	self.height = math.ceil(items / 5) * 35 + 25
	--ChatOutput(name .. " " .. items .. " " .. self.height)
	self:SetSize(self.width + 10, self.height + 10)

	local HeaderLabel = Turbine.UI.Label()
    HeaderLabel:SetParent(self)
    HeaderLabel:SetPosition(0, 0)
    HeaderLabel:SetSize(self.width, 25)
    HeaderLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    HeaderLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiqua18)
    HeaderLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    HeaderLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    --HeaderLabel:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))
    HeaderLabel:SetText(name)
    HeaderLabel:SetMouseVisible(false)

	self.itemListBox = Turbine.UI.ListBox()
	self.itemListBox:SetParent(self)
	self.itemListBox:SetMaxItemsPerLine( 5 );
	self.itemListBox:SetPosition(0, 25)
	self.itemListBox:SetSize(self.width, self.height - 25)
	--self.itemListBox:SetBackColor(Turbine.UI.Color(1,0,0))
	self.itemListBox:SetOrientation( Turbine.UI.Orientation.Horizontal );
	self.itemListBox:SetAllowDrop(true)

	self.itemListBox.DragDrop = function( sender, args )
		local shortcut = args.DragDropInfo:GetShortcut();

		if ( shortcut ~= nil ) then
			local item = self.itemListBox:GetItemAt( args.X, args.Y );
			local index = item:GetIndex()
			
			self.parent:GetBackpack():PerformShortcutDrop( shortcut, index, Turbine.UI.Control.IsShiftKeyDown() );
		end
	end

end

function CategoryListBox:AddItem(item)
	self.itemListBox:AddItem(item)
end

function CategoryListBox:ClearItems()
	self.itemListBox:ClearItems()
end

function CategoryListBox:GetItemCount()
	return(self.itemListBox:GetItemCount())
end
