DamageHandler = class(Turbine.UI.Window)
function DamageHandler:Constructor()

    self.width = 1080
    self.height = 500
    local x = 500
    local y = 200

    self.IconSize = 32

    self.CurrentOutput = ""

    self.ChatOutput = Settings.ChatOutput
    
    self.oldGameTime = Turbine.Engine.GetGameTime()
    self.UpdateDelay = 0.1

    self.CurrentTimeStamp = Turbine.Engine.GetGameTime()

    self.CurrentItem = 0

    local Player = Turbine.Gameplay.LocalPlayer.GetInstance()

    -- Stats
    self.StartTimesLUT = {}
    self.CurrentTotalDamage = {}
    self.TotalHits = {}
    self.TotalCrits = {}
    self.TotalDevs = {}
    self.Actions = {}
    self.ItemActions = {}
    self.MaxDamage = {}
    self.SkillDamage = {}
    --self.CurrentDPS = 0
    self.DPSMapped = {}
    self.TargetBreakdown = {}

    self.SkillsMapped = {}

    self.ItemsMapped = {}

    self.SkillIcons = {}

    self.SkillModulo = 0
    self.ItemModulo = 0

    self.CurrentViewingTime = 0

    self.BarWidth = 5
    self.MaxDps = 0
    self.EndingDPS = 0

    self.CombatStartTime = Turbine.Engine.GetGameTime()

    XIcon = "PrimePlugins/RaidTools/Images/X.tga"
    MoveIcon = "PrimePlugins/RaidTools/Images/Move.tga"

    Turbine.UI.Window.Constructor(self);
    self:SetSize(self.width,self.height);
    self:SetPosition(x,y);
    --self:SetZOrder(1);

    --self:SetMouseVisible(false)
    self:SetVisible(false)
    self:SetWantsUpdates(true)
    self:SetWantsKeyEvents(true)

    self.KeyDown = function(sender, args)
        if args["Action"] == 145 then
            if self:IsVisible() then self:SetVisible(false) end
        end
    end

    self:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    local ColorBackground = Turbine.UI.Control()
    ColorBackground:SetParent(self)
    ColorBackground:SetPosition(10, 10)
    ColorBackground:SetSize(self.width - 20, self.height - 20)
    ColorBackground:SetMouseVisible(false)
    ColorBackground:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    -- Reload button
    local ReloadBackground = Turbine.UI.Control()
    ReloadBackground:SetParent(self)
    ReloadBackground:SetPosition(10, 10)
    ReloadBackground:SetSize(35, 35)
    ReloadBackground:SetMouseVisible(false)
    ReloadBackground:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    local Image = Turbine.UI.Label()
    Image:SetParent(ReloadBackground)
    Image:SetPosition(0, 0)
    Image:SetSize(25, 25)
    Image:SetBackColor(Turbine.UI.Color(0, 102/255, 0))
    Image:SetWantsKeyEvents(false)
    Image:SetMouseVisible(false)

    local ClearButton = Turbine.UI.Label()
    ClearButton:SetParent(ReloadBackground)
    ClearButton:SetPosition(0, 0)
    ClearButton:SetSize(25, 25)
    ClearButton:SetBackground(MoveIcon)
    ClearButton:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    ClearButton:SetBlendMode(Turbine.UI.BlendMode.Overlay)
    ClearButton:SetWantsKeyEvents(false)
    ClearButton:SetMouseVisible(true)
    
    -- Close Button
    local CloseBackground = Turbine.UI.Control()
    CloseBackground:SetParent(self)
    CloseBackground:SetPosition(self.width - 45, 10)
    CloseBackground:SetSize(35, 35)
    CloseBackground:SetMouseVisible(false)
    CloseBackground:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    local Image = Turbine.UI.Label()
    Image:SetParent(CloseBackground)
    Image:SetPosition(10, 0)
    Image:SetSize(25, 25)
    Image:SetBackColor(Turbine.UI.Color(153/255, 0, 0))
    Image:SetWantsKeyEvents(false)
    Image:SetMouseVisible(false)

    local Button = Turbine.UI.Label()
    Button:SetParent(CloseBackground)
    Button:SetPosition(10, 0)
    Button:SetSize(25, 25)
    Button:SetBackground(XIcon)
    Button:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    Button:SetBlendMode(Turbine.UI.BlendMode.Overlay)
    Button:SetWantsKeyEvents(false)
    Button:SetMouseVisible(true)

    Button.MouseClick = function()
        self:SetVisible(false)
    end

    self.Moving = false

    self.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end
  
    self.MouseUp = function()
        self.Moving = false
    end
  
    self.MouseMove = function(sender,args)
        if self.Moving then
          local newLeft = self:GetLeft() - (self.MoveX - args.X)
          local newTop = self:GetTop() - (self.MoveY - args.Y)
          self:SetPosition(newLeft,newTop)
        end
    end

    local TargetBreakdownContainer = Turbine.UI.Control()
    TargetBreakdownContainer:SetParent(self)
    TargetBreakdownContainer:SetPosition(760 - 5, 80 - 5)
    TargetBreakdownContainer:SetSize(280,220)
    TargetBreakdownContainer:SetMouseVisible(false)
    TargetBreakdownContainer:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    local TargetBreakdownContainer = Turbine.UI.Control()
    TargetBreakdownContainer:SetParent(self)
    TargetBreakdownContainer:SetPosition(760, 80)
    TargetBreakdownContainer:SetSize(280 - 10, 220 - 10)
    TargetBreakdownContainer:SetMouseVisible(false)
    TargetBreakdownContainer:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))

    local TargetDamageContainer = Turbine.UI.ListBox()
    TargetDamageContainer:SetParent(TargetBreakdownContainer)
    TargetDamageContainer:SetSize(280-10, 220 - 10)
    TargetDamageContainer:SetPosition(0, 0)
    TargetDamageContainer:SetVisible(true)
    --TargetDamageContainer:SetBackColor(GetRandomColour())
    TargetDamageContainer:SetOrientation( Turbine.UI.Orientation.Vertical );

    local TargetDamageContainerScrollbar = Turbine.UI.Lotro.ScrollBar();
    TargetDamageContainerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical );
    TargetDamageContainerScrollbar:SetParent( TargetBreakdownContainer );
    TargetDamageContainerScrollbar:SetPosition( 280-10, 0 );
    TargetDamageContainerScrollbar:SetSize( 10, 200 - 10 );
    TargetDamageContainerScrollbar:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))
    TargetDamageContainer:SetVerticalScrollBar( TargetDamageContainerScrollbar );

    self.TargetDamageItem = function(Name, Damage, Time)

        local ListItem = Turbine.UI.Control()
        ListItem:SetSize(270, 34)
        ListItem:SetMouseVisible(true)
        ListItem:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))

        local BackGroundControl = Turbine.UI.Control()
        BackGroundControl:SetParent(ListItem)
        BackGroundControl:SetSize(270, 30)
        BackGroundControl:SetPosition(0, 2)
        BackGroundControl:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))

        local NameLabel = Turbine.UI.Label()
        NameLabel:SetParent(ListItem)
        NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        NameLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
        NameLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        NameLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
        NameLabel:SetSize(170, 30)
        NameLabel:SetPosition(0, 2)
        NameLabel:SetMultiline(false)
        NameLabel:SetText(Name)

        
        local DamageLabel = Turbine.UI.Label()
        DamageLabel:SetParent(ListItem)
        DamageLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight)
        DamageLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
        DamageLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        DamageLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
        DamageLabel:SetSize(120, 30)
        DamageLabel:SetMultiline(false)
        DamageLabel:SetPosition(150,2)
        DamageLabel:SetText(FormatBigNumber(Damage) .. "(" .. Round(Damage / self.CurrentTotalDamage[Time] * 100, 2) .. "%)" )

        ListItem.MouseEnter = function()
            BackGroundControl:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))
        end

        ListItem.MouseLeave = function()
            BackGroundControl:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))
        end

        TargetDamageContainer:AddItem(ListItem)
    end

    local StatContainer = Turbine.UI.Control()
    StatContainer:SetParent(self)
    StatContainer:SetPosition(550 - 5, 80 - 5)
    StatContainer:SetSize(200, 200 + 20)
    StatContainer:SetMouseVisible(false)
    StatContainer:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    local StatContainer = Turbine.UI.Control()
    StatContainer:SetParent(self)
    StatContainer:SetPosition(550, 80)
    StatContainer:SetSize(200 - 10, 200 + 20 - 10)
    StatContainer:SetMouseVisible(false)
    StatContainer:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))

    local SkillStatContainer = Turbine.UI.Control()
    SkillStatContainer:SetParent(self)
    SkillStatContainer:SetPosition(840 - 5, 310 - 5)
    SkillStatContainer:SetSize(200, self.IconSize * 5 + 10)
    SkillStatContainer:SetMouseVisible(false)
    SkillStatContainer:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    local SkillStatContainer = Turbine.UI.Control()
    SkillStatContainer:SetParent(self)
    SkillStatContainer:SetPosition(840, 310)
    SkillStatContainer:SetSize(200 - 10, self.IconSize * 5)
    SkillStatContainer:SetMouseVisible(false)
    SkillStatContainer:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))

    local HeaderDivider = Turbine.UI.Control()
    HeaderDivider:SetParent(SkillStatContainer)
    HeaderDivider:SetSize(200, 30)
    HeaderDivider:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    local HeaderLabel = Turbine.UI.Label()
    HeaderLabel:SetParent(SkillStatContainer)
    HeaderLabel:SetPosition(0, 0)
    HeaderLabel:SetSize(200, 25)
    HeaderLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    HeaderLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
    HeaderLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    HeaderLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    HeaderLabel:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))
    HeaderLabel:SetText("Skill Stats")
    HeaderLabel:SetMouseVisible(false)

    local SkillDamageLabel = Turbine.UI.Label()
    SkillDamageLabel:SetParent(SkillStatContainer)
    SkillDamageLabel:SetPosition(0, 30)
    SkillDamageLabel:SetSize(200, 20)
    SkillDamageLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    SkillDamageLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    SkillDamageLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    SkillDamageLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    SkillDamageLabel:SetText("DPS: ")
    SkillDamageLabel:SetMouseVisible(false)

    local SkillMaxDamageLabel = Turbine.UI.Label()
    SkillMaxDamageLabel:SetParent(SkillStatContainer)
    SkillMaxDamageLabel:SetPosition(0, 50)
    SkillMaxDamageLabel:SetSize(300, 20)
    SkillMaxDamageLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    SkillMaxDamageLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    SkillMaxDamageLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    SkillMaxDamageLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    SkillMaxDamageLabel:SetText("Max Damage: ")
    SkillMaxDamageLabel:SetMouseVisible(false)

    local SkillTotalDamageLabel = Turbine.UI.Label()
    SkillTotalDamageLabel:SetParent(SkillStatContainer)
    SkillTotalDamageLabel:SetPosition(0, 70)
    SkillTotalDamageLabel:SetSize(300, 20)
    SkillTotalDamageLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    SkillTotalDamageLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    SkillTotalDamageLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    SkillTotalDamageLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    SkillTotalDamageLabel:SetText("Total Damage: ")
    SkillTotalDamageLabel:SetMouseVisible(false)

    local SkillTotalHitsLabel = Turbine.UI.Label()
    SkillTotalHitsLabel:SetParent(SkillStatContainer)
    SkillTotalHitsLabel:SetPosition(0, 90)
    SkillTotalHitsLabel:SetSize(300, 20)
    SkillTotalHitsLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    SkillTotalHitsLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    SkillTotalHitsLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    SkillTotalHitsLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    SkillTotalHitsLabel:SetText("Total Hits: ")
    SkillTotalHitsLabel:SetMouseVisible(false)

    local SkillTotalCritsLabel = Turbine.UI.Label()
    SkillTotalCritsLabel:SetParent(SkillStatContainer)
    SkillTotalCritsLabel:SetPosition(0, 110)
    SkillTotalCritsLabel:SetSize(300, 20)
    SkillTotalCritsLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    SkillTotalCritsLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    SkillTotalCritsLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    SkillTotalCritsLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    SkillTotalCritsLabel:SetText("Crits: ")
    SkillTotalCritsLabel:SetMouseVisible(false)

    local SkillTotalDevLabel = Turbine.UI.Label()
    SkillTotalDevLabel:SetParent(SkillStatContainer)
    SkillTotalDevLabel:SetPosition(0, 130)
    SkillTotalDevLabel:SetSize(300, 20)
    SkillTotalDevLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    SkillTotalDevLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    SkillTotalDevLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    SkillTotalDevLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    SkillTotalDevLabel:SetText("Devs: ")
    SkillTotalDevLabel:SetMouseVisible(false)

    local ContainerContainer = Turbine.UI.Control()
    ContainerContainer:SetParent(self)
    ContainerContainer:SetPosition(40 - 5, 80 - 5)
    ContainerContainer:SetSize(500, 220)
    ContainerContainer:SetMouseVisible(false)
    ContainerContainer:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    local ContainerContainer = Turbine.UI.Control()
    ContainerContainer:SetParent(self)
    ContainerContainer:SetPosition(40, 80)
    ContainerContainer:SetSize(500 - 10, 220 - 10)
    ContainerContainer:SetMouseVisible(false)
    ContainerContainer:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))

    local damageContainer = Turbine.UI.ListBox()
    damageContainer:SetParent(self)
    damageContainer:SetSize(500-10, 200)
    damageContainer:SetPosition(40, 80)
    --damageContainer:SetBackColor(Turbine.UI.Color(0,0,0))
    damageContainer:SetVisible(true)
    damageContainer:SetOrientation( Turbine.UI.Orientation.Horizontal );
    --damageContainer:SetFlippedLayout(true)
    --damageContainer:SetReverseFill(true)
    --damageContainer:SetWantsKeyEvents(true)
    --damageContainer:SetMouseVisible(true)

    local GraphLine = Turbine.UI.Control()
    GraphLine:SetParent(self)
    GraphLine:SetSize(490, 1)
    GraphLine:SetPosition(40, 80)
    GraphLine:SetMouseVisible(false)
    GraphLine:SetBackColor(Turbine.UI.Color(1,1,1))

    local GraphLine = Turbine.UI.Control()
    GraphLine:SetParent(self)
    GraphLine:SetSize(490, 1)
    GraphLine:SetPosition(40, 132)
    GraphLine:SetMouseVisible(false)
    GraphLine:SetBackColor(Turbine.UI.Color(1,1,1))

    local GraphLine = Turbine.UI.Control()
    GraphLine:SetParent(self)
    GraphLine:SetSize(490, 1)
    GraphLine:SetPosition(40, 185)
    GraphLine:SetMouseVisible(false)
    GraphLine:SetBackColor(Turbine.UI.Color(1,1,1))

    local GraphLine = Turbine.UI.Control()
    GraphLine:SetParent(self)
    GraphLine:SetSize(490, 1)
    GraphLine:SetPosition(40, 237)
    GraphLine:SetMouseVisible(false)
    GraphLine:SetBackColor(Turbine.UI.Color(1,1,1))

    local GraphLine = Turbine.UI.Control()
    GraphLine:SetParent(self)
    GraphLine:SetSize(490, 1)
    GraphLine:SetPosition(40, 280)
    GraphLine:SetMouseVisible(false)
    GraphLine:SetBackColor(Turbine.UI.Color(1,1,1))

    local GraphLabel1 = Turbine.UI.Label()
    GraphLabel1:SetParent(self)
    GraphLabel1:SetSize(80, 20)
    GraphLabel1:SetPosition(450, 80)
    GraphLabel1:SetTextAlignment(Turbine.UI.ContentAlignment.TopRight)
    GraphLabel1:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    GraphLabel1:SetFontStyle(Turbine.UI.FontStyle.Outline)
    GraphLabel1:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    GraphLabel1:SetMouseVisible(false)
    --GraphLabel1:SetBackColor(Turbine.UI.Color(1,1,1))
    GraphLabel1:SetText("0")

    local GraphLabel2 = Turbine.UI.Label()
    GraphLabel2:SetParent(self)
    GraphLabel2:SetSize(80, 20)
    GraphLabel2:SetPosition(450, 185)
    GraphLabel2:SetTextAlignment(Turbine.UI.ContentAlignment.TopRight)
    GraphLabel2:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    GraphLabel2:SetFontStyle(Turbine.UI.FontStyle.Outline)
    GraphLabel2:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    GraphLabel2:SetMouseVisible(false)
    --GraphLabel2:SetBackColor(Turbine.UI.Color(1,1,1))
    GraphLabel2:SetText("0")

    local GraphLabel3 = Turbine.UI.Label()
    GraphLabel3:SetParent(self)
    GraphLabel3:SetSize(80, 20)
    GraphLabel3:SetPosition(450, 260)
    GraphLabel3:SetTextAlignment(Turbine.UI.ContentAlignment.BottomRight)
    GraphLabel3:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    GraphLabel3:SetFontStyle(Turbine.UI.FontStyle.Outline)
    GraphLabel3:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    GraphLabel3:SetMouseVisible(false)
    --GraphLabel3:SetBackColor(Turbine.UI.Color(1,1,1))
    GraphLabel3:SetText("0")

    self.SetGraphLabelText = function()
        GraphLabel2:SetText(FormatBigNumber(self.MaxDps * 0.5))
        GraphLabel1:SetText(FormatBigNumber(self.MaxDps))
    end


    local damageContainerScrollbar = Turbine.UI.Lotro.ScrollBar();
    damageContainerScrollbar:SetOrientation( Turbine.UI.Orientation.Horizontal );
    damageContainerScrollbar:SetParent( self );
    damageContainerScrollbar:SetPosition( 40, 280 );
    damageContainerScrollbar:SetSize( 500 - 10, 10 );
    damageContainer:SetHorizontalScrollBar( damageContainerScrollbar );

    local SkillContainerContainer = Turbine.UI.Control()
    SkillContainerContainer:SetParent(self)
    SkillContainerContainer:SetPosition(40 - 5, 310 - 5)
    SkillContainerContainer:SetSize(500, self.IconSize * 5 + 10)
    SkillContainerContainer:SetMouseVisible(false)
    SkillContainerContainer:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    local SkillContainerContainer = Turbine.UI.Control()
    SkillContainerContainer:SetParent(self)
    SkillContainerContainer:SetPosition(40, 310)
    SkillContainerContainer:SetSize(500 - 10, self.IconSize * 5 )
    SkillContainerContainer:SetMouseVisible(false)
    SkillContainerContainer:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))

    local skillContainer = Turbine.UI.Control()
    skillContainer:SetParent(self)
    skillContainer:SetSize(500 - 10, self.IconSize * 5)
    skillContainer:SetPosition(40, 310)
    --skillContainer:SetBackColor(Turbine.UI.Color(0,0,0))
    skillContainer:SetVisible(true)
    --skillContainer:SetForeColor(Turbine.UI.Color(0,0,0))
    --skillContainer:SetText("IIIIIIIIIII")
    --skillContainer:SetOrientation( Turbine.UI.Orientation.Horizontal );
    --skillContainer:SetIgnoreCellAlignment(true)
    --skillContainer:SetFlippedLayout(true)
    --skillContainer:SetReverseFill(true)
    --skillContainer:SetWantsKeyEvents(true)
    --skillContainer:SetMouseVisible(true)

    local itemContainer = Turbine.UI.Control()
    itemContainer:SetParent(self)
    itemContainer:SetSize(500, 80)
    itemContainer:SetPosition(40, 370)
    --itemContainer:SetBackColor(Turbine.UI.Color(0,0,0))
    itemContainer:SetVisible(true)

    local SkillBreakdownContainer = Turbine.UI.Control()
    SkillBreakdownContainer:SetParent(self)
    SkillBreakdownContainer:SetPosition(550 - 5, 310 - 5)
    SkillBreakdownContainer:SetSize(280, self.IconSize * 5 + 10)
    SkillBreakdownContainer:SetMouseVisible(false)
    SkillBreakdownContainer:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    local SkillBreakdownContainer = Turbine.UI.Control()
    SkillBreakdownContainer:SetParent(self)
    SkillBreakdownContainer:SetPosition(550, 310)
    SkillBreakdownContainer:SetSize(280 - 10, self.IconSize * 5 - 10 + 10)
    SkillBreakdownContainer:SetMouseVisible(false)
    SkillBreakdownContainer:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))

    local skillDamageContainer = Turbine.UI.ListBox()
    skillDamageContainer:SetParent(SkillBreakdownContainer)
    skillDamageContainer:SetSize(280-10, self.IconSize * 5 - 10 + 10)
    skillDamageContainer:SetPosition(0, 0)
    skillDamageContainer:SetVisible(true)
    --skillDamageContainer:SetBackColor(GetRandomColour())
    skillDamageContainer:SetOrientation( Turbine.UI.Orientation.Vertical );

    local skillDamageContainerScrollbar = Turbine.UI.Lotro.ScrollBar();
    skillDamageContainerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical );
    skillDamageContainerScrollbar:SetParent( SkillBreakdownContainer );
    skillDamageContainerScrollbar:SetPosition( 280-10, 0 );
    skillDamageContainerScrollbar:SetSize( 10, self.IconSize * 5 - 10 + 10 );
    skillDamageContainerScrollbar:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))
    skillDamageContainer:SetVerticalScrollBar( skillDamageContainerScrollbar );

    self.AddSkillDamageLabel = function(Name, SkillItem, Time)
        local Damage = SkillItem[1]

        local ListItem = Turbine.UI.Control()
        ListItem:SetSize(270, 34)
        ListItem:SetMouseVisible(true)
        ListItem:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))

        local BackGroundControl = Turbine.UI.Control()
        BackGroundControl:SetParent(ListItem)
        BackGroundControl:SetSize(270, 30)
        BackGroundControl:SetPosition(0, 2)
        BackGroundControl:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))

        local NameLabel = Turbine.UI.Label()
        NameLabel:SetParent(ListItem)
        NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        NameLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
        NameLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        NameLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
        NameLabel:SetSize(150, 30)
        NameLabel:SetPosition(0, 2)
        NameLabel:SetText(Name)

        
        local DamageLabel = Turbine.UI.Label()
        DamageLabel:SetParent(ListItem)
        DamageLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight)
        DamageLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
        DamageLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        DamageLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
        DamageLabel:SetSize(120, 30)
        DamageLabel:SetMultiline(false)
        DamageLabel:SetPosition(140,2)
        DamageLabel:SetText(FormatBigNumber(Damage) .. "(" .. Round(Damage / self.CurrentTotalDamage[Time] * 100, 2) .. "%)" )

        ListItem.MouseEnter = function()
            BackGroundControl:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))
            SkillDamageLabel:SetText("DPS: " .. Round(Damage / (self.StartTimesLUT[Time] - Time), 2))
            SkillMaxDamageLabel:SetText("Max Damage: " .. SkillItem[2])
            SkillTotalDamageLabel:SetText("Total Damage: " .. Damage)
            SkillTotalHitsLabel:SetText("Total Hits: " .. SkillItem[3])
            SkillTotalCritsLabel:SetText("Crits: " .. SkillItem[4] .. " (" .. Round(SkillItem[4] / SkillItem[3] * 100, 2) .. "%)" )
            SkillTotalDevLabel:SetText("Devs: " .. SkillItem[5]  .. " (" .. Round(SkillItem[5] / SkillItem[3] * 100, 2) .. "%)")
        end

        ListItem.MouseLeave = function()
            BackGroundControl:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))
        end

        skillDamageContainer:AddItem(ListItem)
    end

    --[[
    local skillContainerScrollbar = Turbine.UI.Lotro.ScrollBar();
    skillContainerScrollbar:SetOrientation( Turbine.UI.Orientation.Horizontal );
    skillContainerScrollbar:SetParent( self );
    skillContainerScrollbar:SetPosition( 10, 390 );
    skillContainerScrollbar:SetSize( 480, 10 );
    skillContainer:SetHorizontalScrollBar( skillContainerScrollbar );
    --]]
    --skillContainer:SetHorizontalScrollBar( damageContainerScrollbar );

    --damageContainer:GetValue()

    -- Setup UI
    local HeaderDivider = Turbine.UI.Control()
    HeaderDivider:SetParent(StatContainer)
    HeaderDivider:SetSize(200, 30)
    HeaderDivider:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    local HeaderLabel = Turbine.UI.Label()
    HeaderLabel:SetParent(StatContainer)
    HeaderLabel:SetPosition(0, 0)
    HeaderLabel:SetSize(200, 25)
    HeaderLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    HeaderLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
    HeaderLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    HeaderLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    HeaderLabel:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))
    HeaderLabel:SetText("DPS Stats")
    HeaderLabel:SetMouseVisible(false)

    local DamageLabel = Turbine.UI.Label()
    DamageLabel:SetParent(StatContainer)
    DamageLabel:SetPosition(0, 30)
    DamageLabel:SetSize(200, 20)
    DamageLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    DamageLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    DamageLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    DamageLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    DamageLabel:SetText("DPS: ")
    DamageLabel:SetMouseVisible(false)

    local TimeStampLabel = Turbine.UI.Label()
    TimeStampLabel:SetParent(StatContainer)
    TimeStampLabel:SetPosition(0, 50)
    TimeStampLabel:SetSize(200, 20)
    TimeStampLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    TimeStampLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    TimeStampLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    TimeStampLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    TimeStampLabel:SetText("TimeStamp: ")
    TimeStampLabel:SetMouseVisible(false)

    local TotalDamageLabel = Turbine.UI.Label()
    TotalDamageLabel:SetParent(StatContainer)
    TotalDamageLabel:SetPosition(0, 70)
    TotalDamageLabel:SetSize(300, 20)
    TotalDamageLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    TotalDamageLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    TotalDamageLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    TotalDamageLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    TotalDamageLabel:SetText("Total Damage: ")
    TotalDamageLabel:SetMouseVisible(false)

    local TotalHitsLabel = Turbine.UI.Label()
    TotalHitsLabel:SetParent(StatContainer)
    TotalHitsLabel:SetPosition(0, 90)
    TotalHitsLabel:SetSize(300, 20)
    TotalHitsLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    TotalHitsLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    TotalHitsLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    TotalHitsLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    TotalHitsLabel:SetText("Total Hits: ")
    TotalHitsLabel:SetMouseVisible(false)

    local TotalCritsLabel = Turbine.UI.Label()
    TotalCritsLabel:SetParent(StatContainer)
    TotalCritsLabel:SetPosition(0, 110)
    TotalCritsLabel:SetSize(300, 20)
    TotalCritsLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    TotalCritsLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    TotalCritsLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    TotalCritsLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    TotalCritsLabel:SetText("Crits: ")
    TotalCritsLabel:SetMouseVisible(false)

    local TotalDevLabel = Turbine.UI.Label()
    TotalDevLabel:SetParent(StatContainer)
    TotalDevLabel:SetPosition(0, 130)
    TotalDevLabel:SetSize(300, 20)
    TotalDevLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    TotalDevLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    TotalDevLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    TotalDevLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    TotalDevLabel:SetText("Devs: ")
    TotalDevLabel:SetMouseVisible(false)

    local ActionLabel = Turbine.UI.Label()
    ActionLabel:SetParent(StatContainer)
    ActionLabel:SetPosition(0, 150)
    ActionLabel:SetSize(300, 20)
    ActionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    ActionLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    ActionLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    ActionLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    ActionLabel:SetText("Actions: ")
    ActionLabel:SetMouseVisible(false)

    local ActionPerSecondLabel = Turbine.UI.Label()
    ActionPerSecondLabel:SetParent(StatContainer)
    ActionPerSecondLabel:SetPosition(0, 170)
    ActionPerSecondLabel:SetSize(300, 20)
    ActionPerSecondLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    ActionPerSecondLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    ActionPerSecondLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    ActionPerSecondLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    ActionPerSecondLabel:SetText("APS: ")
    ActionPerSecondLabel:SetMouseVisible(false)

    local ItemActionPerSecondLabel = Turbine.UI.Label()
    ItemActionPerSecondLabel:SetParent(StatContainer)
    ItemActionPerSecondLabel:SetPosition(0, 190)
    ItemActionPerSecondLabel:SetSize(300, 20)
    ItemActionPerSecondLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    ItemActionPerSecondLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    ItemActionPerSecondLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    ItemActionPerSecondLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    ItemActionPerSecondLabel:SetText("I+APS: ")
    ItemActionPerSecondLabel:SetMouseVisible(false)

    -- Add item to damageContainer
    self.AdddamageContainerItem = function(DPSValue, TimeStamp, StartTime)
        local MiddleValue = DPSValue / self.MaxDps * 200
        local Entry = Turbine.UI.Control()
        Entry:SetSize(self.BarWidth, 200)
        Entry:IsMouseVisible(true)
        --Entry:SetBackColor(GetRandomColour())

        local bottomBar = Turbine.UI.Label()
        bottomBar:SetParent(Entry)
        bottomBar:SetSize(self.BarWidth, MiddleValue)
        bottomBar:SetPosition(0, 200 - MiddleValue)
        bottomBar:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

        local line = Turbine.UI.Label()
        line:SetParent(Entry)
        line:SetSize(self.BarWidth,5)
        line:SetPosition(0, 200 - MiddleValue)
        line:SetBackColor(Turbine.UI.Color(1, 102/255, 0))

        --self.GraphDamage = self.GraphDamage + MiddleValue
        local totalDamage = self.CurrentTotalDamage[StartTime]
        local time = TimeStamp

        Entry.MouseEnter = function()
            DamageLabel:SetText("DPS: " .. Round(DPSValue, 2))
            TimeStampLabel:SetText("TimeStamp: " .. Round(TimeStamp - StartTime, 2) .. "s")
            TotalDamageLabel:SetText("Total Damage: " .. math.floor(totalDamage))
            bottomBar:SetBackColor(Turbine.UI.Color(1, 102/255, 0))

            if self.SkillsMapped[StartTime][time] then
                    
                for key, value in pairs(self.SkillIcons[StartTime][time]) do
                    value:SetBackColor(Turbine.UI.Color(0, 1, 0))
                end

            end
        end

        Entry.MouseLeave = function()
            bottomBar:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

            if self.SkillsMapped[StartTime][time] then
                    
                for key, value in pairs(self.SkillIcons[StartTime][time]) do
                    value:SetBackColor(nil)
                end

            end
        end
    
        damageContainer:AddItem(Entry)

        local StartPosition = nil

        Entry.PositionChanged = function(sender, args)
            if StartPosition then
                local PositionChange = Entry:GetLeft() - StartPosition
                if self.SkillsMapped[StartTime][time] or self.ItemsMapped[StartTime][time] then
                    
                    for key, value in pairs(self.SkillIcons[StartTime][time]) do
                        value:SetLeft(value:GetLeft() + PositionChange)
                    end

                end
            end
            StartPosition = Entry:GetPosition()
            --for key, value in pairs(args) do
            --end
            --ChatOutput("X")
        end
    end

    self.ItemIcon = function()
    end

    self.SkillIcon = function(startTime, time, item, icon, name)
        local skillLabel = Turbine.UI.Label()
        skillLabel:SetParent(skillContainer)
        skillLabel:SetSize(32, 32)
        skillLabel:SetStretchMode(1)
        skillLabel:SetPosition((item - 1) * self.BarWidth, self.SkillModulo)
        skillLabel:SetBackground(icon)
        skillLabel:SetSize(self.IconSize, self.IconSize)

        if skillLabel:GetLeft() < 0 or skillLabel:GetLeft() > 490 - 32 then
            skillLabel:SetVisible(false)
        else
            skillLabel:SetVisible(true)
        end

        skillLabel.PositionChanged = function()
            local XCord = skillLabel:GetLeft() 
            if XCord < 0 or XCord > 490 - 32 then
                skillLabel:SetVisible(false)
            else
                skillLabel:SetVisible(true)
            end
        end
        self.SkillModulo = (self.SkillModulo + self.IconSize) % (self.IconSize * 5)

        if not(self.SkillIcons[startTime][time]) then
            self.SkillIcons[startTime][time] = {}
        end

        self.SkillIcons[startTime][time][name] = skillLabel
    end

    -- Setup Skill Usage Tracking
    local tskills = Player:GetTrainedSkills()

    --[[
    local ClassAttr
    if Player:GetClass() == Turbine.Gameplay.Class.Warden then
        ClassAttr = Player:GetClassAttributes():GetTrainedGambits()
    end

    for i = 1, ClassAttr:GetCount(), 1 do
        local item = ClassAttr:GetItem(i)
        ChatOutput(item:GetSkillInfo():GetName())
    end
    ClassAttr.GambitChanged = function(sender, args)
        for key, value in pairs(args) do
            ChatOutput(key)
            ChatOutput(value)
        end
    end
    --]]

    for i = 1, Player:GetTrainedSkills():GetCount(), 1 do
        local item = tskills:GetItem(i)--:GetSkillInfo()
        if item.GetCooldown then
            item.ResetTimeChanged = function()
                if Player:IsInCombat() and item:GetCooldown() - 0.1 < item:GetResetTime() - Turbine.Engine.GetGameTime() then
                    self.Actions[self.CombatStartTime] = self.Actions[self.CombatStartTime] + 1
                    ActionLabel:SetText("Actions: " .. self.Actions[self.CombatStartTime])

                    if not(self.SkillsMapped[self.CombatStartTime][self.CurrentTimeStamp]) then
                        self.SkillsMapped[self.CombatStartTime][self.CurrentTimeStamp] = {}
                    end
                    --ChatOutput(item:GetSkillInfo():GetName() )
        
                    self.SkillsMapped[self.CombatStartTime][self.CurrentTimeStamp][item:GetSkillInfo():GetName()] = {self.CurrentItem, item:GetSkillInfo():GetIconImageID(), item:GetSkillInfo():GetName()}

                    --self.SkillIcon(self.CurrentItem, self.SkillsMapped[self.CombatStartTime][self.CurrentTimeStamp][item:GetSkillInfo():GetName()][1], self.SkillsMapped[self.CombatStartTime][self.CurrentTimeStamp][item:GetSkillInfo():GetName()][2], self.SkillsMapped[self.CombatStartTime][self.CurrentTimeStamp][item:GetSkillInfo():GetName()][3])
                    --self.AddSkillContainerItem(self.CurrentItem, self.CurrentTimeStamp)
                end
            end
        end
        --local name = item:GetSkillInfo():GetName() 
        --local description = item:GetSkillInfo():GetDescription()
    end

    self.ItemLabel = function(startTime, time, item, icon, background, name)

        local skillLabel = Turbine.UI.Label()
        skillLabel:SetParent(skillContainer)
        skillLabel:SetPosition((item - 1) * self.BarWidth, self.SkillModulo)
        skillLabel:SetSize(self.IconSize, self.IconSize)

        -- [[
        local backgroundLabel = Turbine.UI.Label()
        backgroundLabel:SetParent(skillLabel)
        backgroundLabel:SetSize(32, 32)
        backgroundLabel:SetStretchMode(1)
        backgroundLabel:SetBackground(background)
        backgroundLabel:SetSize(self.IconSize, self.IconSize)

        local iconLabel = Turbine.UI.Label()
        iconLabel:SetParent(skillLabel)
        iconLabel:SetSize(32, 32)
        iconLabel:SetStretchMode(1)
        iconLabel:SetBackground(icon)
        iconLabel:SetSize(self.IconSize, self.IconSize)
        --]]

        if skillLabel:GetLeft() < 0 or skillLabel:GetLeft() > 490 - 32 then
            skillLabel:SetVisible(false)
        else
            skillLabel:SetVisible(true)
        end

        skillLabel.PositionChanged = function()
            local XCord = skillLabel:GetLeft() 
            if XCord < 0 or XCord > 490 - 32 then
                skillLabel:SetVisible(false)
            else
                skillLabel:SetVisible(true)
            end
        end

        self.SkillModulo = (self.SkillModulo + self.IconSize) % (self.IconSize * 5)

        if not(self.SkillIcons[startTime][time]) then
            self.SkillIcons[startTime][time] = {}
        end

        self.SkillIcons[startTime][time][name] = skillLabel
    end

    -- ChatOutput
    local ReloadBackground = Turbine.UI.Control()
    ReloadBackground:SetParent(self)
    ReloadBackground:SetPosition(self.width / 2 + 200, 32)
    ReloadBackground:SetSize(24, 24)
    ReloadBackground:SetMouseVisible(false)
    ReloadBackground:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    self.clearResetButton = Turbine.UI.Lotro.Quickslot()
    self.clearResetButton:SetPosition(0, 0)
    self.clearResetButton:SetSize(24 - 4, 24 - 4)
    self.clearResetButton:SetParent(ReloadBackground)

    self.ResetShortcut = function()
        self.clearResetButton:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias, self.ChatOutput .. self.CurrentOutput))
    end

    self.ResetShortcut()

    local ReloadBorder = Turbine.UI.Control()
    ReloadBorder:SetParent(ReloadBackground)
    ReloadBorder:SetPosition(2, 2)
    ReloadBorder:SetSize(24 - 4, 24 - 4)
    ReloadBorder:SetMouseVisible(false)
    ReloadBorder:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))

    local Image = Turbine.UI.Label()
    Image:SetParent(ReloadBackground)
    Image:SetPosition(2, 2)
    Image:SetSize(24 - 4, 24 - 6)
    Image:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    Image:SetBlendMode(Turbine.UI.BlendMode.Overlay)
    --Image:SetBackColor(Turbine.UI.Color(0, 102/255, 0))
    Image:SetBackground(ChatIcon)
    Image:SetWantsKeyEvents(false)
    Image:SetMouseVisible(false)
    

    -- Handle item swaps
    local equipment = Player:GetEquipment()
    equipment.ItemEquipped = function(sender, args)
        --self:SetVisible(true)
        if Player:IsInCombat() then
            local item = equipment:GetItem(args.Index)
            if item ~= nil then 
                local itemName = item:GetName()

                self.ItemActions[self.CombatStartTime] = self.ItemActions[self.CombatStartTime] + 1

                if not(self.ItemsMapped[self.CombatStartTime][self.CurrentTimeStamp]) then
                    self.ItemsMapped[self.CombatStartTime][self.CurrentTimeStamp] = {}
                end

                --ChatOutput(itemName )

                self.ItemsMapped[self.CombatStartTime][self.CurrentTimeStamp][itemName] = {self.CurrentItem, item:GetItemInfo():GetIconImageID(), item:GetItemInfo():GetBackgroundImageID(), itemName}
            end	
        end
    end

    equipment.ItemUnequipped = function(sender, args)
        --self:SetVisible(false)
        local item = equipment:GetItem(args.Index)
        if item ~= nil then    
            local itemName = item:GetName()    
        end	
    end
    
    self.OutputParse = function(StartTime)
        TableToString(self.DPSMapped[StartTime], "DPSMapped", 0)
        TableToString(self.TargetBreakdown[StartTime], "TargetBreakdown", 0)
        --TableToString(self.SkillsMapped[StartTime], "SkillsMapped")
        --TableToString(self.ItemsMapped[StartTime], "ItemsMapped")
        --TableToString(self.SkillDamage[StartTime], "SkillDamage")
        TableToString({
            ["Actions"] = self.Actions[StartTime], 
            ["ItemActions"] = self.ItemActions[StartTime], 
            ["EndingDPS"] = self.EndingDPS, 
            ["End Time"] = self.StartTimesLUT[StartTime], 
            ["Start Time"] = StartTime, 
            ["Total Damage"] = self.CurrentTotalDamage[StartTime], 
            ["Total Hits"] = self.TotalHits[StartTime], 
            ["Total Crits"] = self.TotalCrits[StartTime], 
            ["Total Devs"] = self.TotalDevs[StartTime]}, "Misc data", 0)
    end

    self.SetupStatWindows = function(StartTime)

        --ChatOutput(StartTime)
        self.CurrentViewingTime = self.CombatStartTime

        -- Setup skill damage breakdown
        if self.SkillDamage[StartTime] then
            for key,value in spairs(self.SkillDamage[StartTime], function(t,a,b) return t[a][1] > t[b][1] end) do
                self.AddSkillDamageLabel(key, value, StartTime)
            end
        end

        -- Setup Target Breakdown
        if self.TargetBreakdown[StartTime] then
            for key,value in spairs(self.TargetBreakdown[StartTime], function(t,a,b) return t[a] > t[b] end) do
                self.TargetDamageItem(key, value, StartTime)
            end
        end

        -- Setup dps graph with mapped skills
        if self.DPSMapped[StartTime] then
            -- Get max dps
            self.MaxDps = -1
            self.PrevDamageItem = 0
            for _, value in pairs(self.DPSMapped[StartTime]) do
                if self.MaxDps < value then self.MaxDps = value end
            end

            self.MaxDps = self.MaxDps * 1.2

            self.SetGraphLabelText()

            for key,value in spairs(self.DPSMapped[StartTime], function(t,a,b) return a < b end) do
                --ChatOutput(key .. " - " .. value)

                -- Add dps bar
                self.AdddamageContainerItem(value, key, StartTime)
                
                -- Add skills 
                if self.SkillsMapped[StartTime][key] then
                    for skill, icon in pairs(self.SkillsMapped[StartTime][key]) do
                        self.SkillIcon(StartTime, key, icon[1], icon[2], icon[3])
                    end
                end

                -- Add items
                if self.ItemsMapped[StartTime][key] then
                    for skill, icon in pairs(self.ItemsMapped[StartTime][key]) do
                        self.ItemLabel(StartTime, key, icon[1], icon[2], icon[3], icon[4])
                    end
                end

                self.EndingDPS = value
            end

            -- Setup labels
            ActionPerSecondLabel:SetText("APS: " .. Round(self.Actions[StartTime] / (Turbine.Engine.GetGameTime() - StartTime) ,2))
            ItemActionPerSecondLabel:SetText("I+APS: " .. Round((self.Actions[StartTime] + self.ItemActions[StartTime]) / (Turbine.Engine.GetGameTime() - StartTime), 2))
            DamageLabel:SetText("DPS: " .. Round(self.EndingDPS, 2))
            TimeStampLabel:SetText("TimeStamp: " .. Round(self.StartTimesLUT[StartTime]  - StartTime, 2))
            TotalDamageLabel:SetText("Total Damage: " .. math.floor(self.CurrentTotalDamage[StartTime]))
            TotalHitsLabel:SetText("Total Hits: " .. self.TotalHits[StartTime])
            TotalCritsLabel:SetText("Crits: " .. Round(self.TotalCrits[StartTime] / self.TotalHits[StartTime] * 100, 2) .. "%")
            TotalDevLabel:SetText("Devs: " .. Round(self.TotalDevs[StartTime] / self.TotalHits[StartTime] * 100, 2) .. "%")

            -- Setup ChatOutput
            --FormatBigNumber(self.CurrentTotalDamage[self.CombatStartTime] / (self.StartTimesLUT[self.CombatStartTime] - self.CombatStartTime)), FormatBigNumber(self.CurrentTotalDamage[self.CombatStartTime]), Round(self.TotalCrits[self.CombatStartTime] / self.TotalHits[self.CombatStartTime] * 100, 2), FormatTimeString(self.StartTimesLUT[self.CombatStartTime] - self.CombatStartTime), HighestTarget)

            local HighestTarget = ""
            if self.TargetBreakdown[StartTime] then
                for key, value in spairs(self.TargetBreakdown[StartTime], function(t,a,b) return t[a] < t[b] end) do
                    --ChatOutput(key)
                    --ChatOutput(value)
                    HighestTarget = key
                    break
                end
            end

            self.CurrentOutput = " <rgb=#06d60d>" .. HighestTarget .. "</rgb> <rgb=#ffffff>-</rgb> <rgb=#a30e0e>DPS:</rgb> <rgb=#ffffff>" .. FormatBigNumber(self.EndingDPS) .. " [" .. math.floor(self.CurrentTotalDamage[StartTime]) .. "] </rgb><rgb=#d8880f>Crit:</rgb> <rgb=#ffffff>" .. Round(self.TotalCrits[StartTime] / self.TotalHits[StartTime] * 100, 2) .. "%</rgb> <rgb=#FF9900>(" .. FormatTimeString(self.StartTimesLUT[self.CombatStartTime] - self.CombatStartTime) .. ")"
            self.ResetShortcut()

            --self.OutputParse(StartTime)
        end

    end

    self.ClearStatWindows = function(StartTime)
        damageContainer:ClearItems()
        skillDamageContainer:ClearItems()
        TargetDamageContainer:ClearItems()
        if self.SkillIcons then
            for key, value in pairs(self.SkillIcons) do
                for key2, value2 in pairs(value) do
                    for key3, value3 in pairs(value2) do
                        value3:SetVisible(false)
                        value3:SetParent(nil)
                    end
                end
            end
        end
        self.SkillModulo = 0
    end

    ClearButton.MouseClick = function()
        self.ClearStatWindows()
    end

    -- Handle combat changes
    self.CombatChanged = function()
        if Player:IsInCombat() then
            --ChatOutput("Combat Started")
            self.CombatStartTime = Turbine.Engine.GetGameTime()
            self.StartTimesLUT[self.CombatStartTime] = Turbine.Engine.GetGameTime()
            self.DPSMapped[self.CombatStartTime] = {}
            self.SkillsMapped[self.CombatStartTime] = {}
            self.ItemsMapped[self.CombatStartTime] = {}
            self.SkillIcons[self.CombatStartTime] = {}
            self.SkillDamage[self.CombatStartTime] = {}
            self.TargetBreakdown[self.CombatStartTime] = {}

            self.CurrentTotalDamage[self.CombatStartTime] = 0
            self.TotalHits[self.CombatStartTime] = 0
            self.TotalCrits[self.CombatStartTime] = 0
            self.TotalDevs[self.CombatStartTime] = 0
            self.Actions[self.CombatStartTime] = 0
            self.ItemActions[self.CombatStartTime] = 0
            self.MaxDamage[self.CombatStartTime] = 0

            self.CurrentItem = 0

            smallPP:StartTimer()
        else
            --ChatOutput("Combat Ended")

            self.StartTimesLUT[self.CombatStartTime] = Turbine.Engine.GetGameTime()

            smallPP:SetWantsUpdates(false)

            if self.CombatStartTime ~= self.StartTimesLUT[self.CombatStartTime] then
                --ChatOutput("\n" .. TableToString(self.DPSMapped[self.CombatStartTime], "DPSMapped", 0))
                local HighestTarget = ""
                if self.TargetBreakdown[self.CombatStartTime] then
                    for key, value in spairs(self.TargetBreakdown[self.CombatStartTime], function(t,a,b) return t[a] < t[b] end) do
                        --ChatOutput(key)
                        --ChatOutput(value)
                        HighestTarget = key
                        break
                    end
                end
                self.AddTimestampEntry(self.CombatStartTime, FormatTimeString(self.StartTimesLUT[self.CombatStartTime] - self.CombatStartTime), HighestTarget)
                smallPP:SetupChatoutput(FormatBigNumber(self.CurrentTotalDamage[self.CombatStartTime] / (self.StartTimesLUT[self.CombatStartTime] - self.CombatStartTime)), FormatBigNumber(self.CurrentTotalDamage[self.CombatStartTime]), Round(self.TotalCrits[self.CombatStartTime] / self.TotalHits[self.CombatStartTime] * 100, 2), FormatTimeString(self.StartTimesLUT[self.CombatStartTime] - self.CombatStartTime), HighestTarget)
            end

            --self.SetupStatWindows(self.CombatStartTime)

            --]]

        end
    end

    self.Update = function()

        local currentGameTime = Turbine.Engine.GetGameTime()
        if currentGameTime == self.oldGameTime then
            return(true)
        end
        local delta = currentGameTime - self.oldGameTime
        if delta < self.UpdateDelay then return end

        self.CurrentTimeStamp = currentGameTime
        self.oldGameTime = currentGameTime

        if Player:IsInCombat() then
            self.CurrentItem = self.CurrentItem + 1

            self.DPSMapped[self.CombatStartTime][self.CurrentTimeStamp] = self.CurrentTotalDamage[self.CombatStartTime] / (Turbine.Engine.GetGameTime() - self.CombatStartTime)
            --self.AdddamageContainerItem(self.DPSMapped[self.CombatStartTime][self.CurrentTimeStamp], currentGameTime)

            smallPP:SetDPS(self.DPSMapped[self.CombatStartTime][self.CurrentTimeStamp])
            --ChatOutput(self.CurrentTotalDamage / (Turbine.Engine.GetGameTime() - self.CombatStartTime) / 50000 * 200)
        end

    end

    

    -- Set Player Events
    Player.InCombatChanged = function()
        self.CombatChanged()
    end

    self.HandleDamage = function(damage, SkillName, HitType, Target)

        -- 1 + 1 = 3
        self.CurrentTotalDamage[self.CombatStartTime] = self.CurrentTotalDamage[self.CombatStartTime] + damage

        -- Detect special hit types
        local hitCategory = 1

        if string.find(HitType, "critical") then
            self.TotalCrits[self.CombatStartTime] = self.TotalCrits[self.CombatStartTime] + 1
            hitCategory = 2
        elseif string.find(HitType, "devastating") then
            self.TotalDevs[self.CombatStartTime] = self.TotalDevs[self.CombatStartTime] + 1
            hitCategory = 3
        else
            --??
        end

        -- Total hits
        self.TotalHits[self.CombatStartTime] = self.TotalHits[self.CombatStartTime] + 1

        -- Handle DPS meter
        smallPP:SetTotal(self.CurrentTotalDamage[self.CombatStartTime])
        smallPP:SetCrit(self.TotalCrits[self.CombatStartTime] / self.TotalHits[self.CombatStartTime] * 100)

        -- Skill damage saving
        if not(self.SkillDamage[self.CombatStartTime][SkillName]) then
            local skillItem = {damage, damage, 1, 0, 0}
            if hitCategory == 2 then skillItem[4] = 1 elseif hitCategory == 3 then skillItem[5] = 1 end
            self.SkillDamage[self.CombatStartTime][SkillName] = skillItem
        else
            local skillItem = self.SkillDamage[self.CombatStartTime][SkillName]
            skillItem[1] = skillItem[1] + damage
            skillItem[3] = skillItem[3] + 1
            if skillItem[2] < damage then skillItem[2] = damage end
            if hitCategory == 2 then skillItem[4] = skillItem[4] + 1 elseif hitCategory == 3 then skillItem[5] = skillItem[5] +  1 end

            self.SkillDamage[self.CombatStartTime][SkillName] = skillItem
        end

        -- Handle target damage
        if self.TargetBreakdown[self.CombatStartTime][Target] then
            self.TargetBreakdown[self.CombatStartTime][Target] = self.TargetBreakdown[self.CombatStartTime][Target] + damage
        else
            self.TargetBreakdown[self.CombatStartTime][Target] = damage
        end
    end

    PlayerName = Player:GetName()
 
    -- Set parse function
    Turbine.Chat.Received = function(sender, args)
        if args.ChatType == Turbine.ChatType.PlayerCombat then
            local Source, HitType, SkillName, Target, damage, damageType = string.match(string.gsub(string.gsub(args.Message,"<rgb=#......>(.*)</rgb>","%1"),"^%s*(.-)%s*$", "%1"),"^(.*) scored a (.*)hit with (.*) on (.*) for (.-) (.*)%.$")
            --local damage, damageType = string.match(string.gsub(string.gsub(args.Message,"<rgb=#......>(.*)</rgb>","%1"),"^%s*(.-)%s*$", "%1"),"for (.-) (.*)%.$")
            --ChatOutput()
            --ChatOutput("Name: " .. Source .. " Type: " .. HitType .. " Skill Type: " .. SkillName .. " Target: " .. Target .. " Damage: " .. damage .. " Damage Type: " .. damageType)
            --ChatOutput(HitType)

            if damage and PlayerName == Source then

                --ChatOutput(string.gsub(damage, ",", ""))-- .. damageType)

                damage = string.gsub(damage, ",", "")
                damage = tonumber(damage)
                if damage > self.MaxDamage[self.CombatStartTime] then self.MaxDamage[self.CombatStartTime] = damage end
                self.HandleDamage(tonumber(damage), SkillName, HitType, Target)
            end
        end
    end

    local SelectionContainer = Turbine.UI.Control()
    SelectionContainer:SetParent(self)
    SelectionContainer:SetPosition(self.width / 2 - 200 - 5, 30 - 5)
    SelectionContainer:SetSize(400, 40)
    SelectionContainer:SetMouseVisible(false)
    SelectionContainer:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    local SelectionContainer = Turbine.UI.Control()
    SelectionContainer:SetParent(self)
    SelectionContainer:SetPosition(self.width / 2 - 200, 30)
    SelectionContainer:SetSize(400 - 10, 40 - 10)
    SelectionContainer:SetMouseVisible(true)
    SelectionContainer:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))

    SelectionContainer.MouseEnter = function()
        SelectionContainer:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))
    end

    SelectionContainer.MouseLeave = function()
        SelectionContainer:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))
    end

    local SelectionContainerPopOutBorder = Turbine.UI.Control()
    SelectionContainerPopOutBorder:SetParent(self)
    SelectionContainerPopOutBorder:SetPosition(self.width / 2 - 200 - 5, 65 - 5)
    SelectionContainerPopOutBorder:SetSize(400, 240)
    SelectionContainerPopOutBorder:SetMouseVisible(false)
    SelectionContainerPopOutBorder:SetVisible(false)
    SelectionContainerPopOutBorder:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))

    local SelectionContainerPopOut = Turbine.UI.Control()
    SelectionContainerPopOut:SetParent(SelectionContainerPopOutBorder)
    SelectionContainerPopOut:SetPosition(5, 5)
    SelectionContainerPopOut:SetSize(400 - 10, 240 - 10)
    SelectionContainerPopOut:SetMouseVisible(true)
    SelectionContainerPopOut:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))
    SelectionContainerPopOut:SetZOrder(100)

    SelectionContainer.MouseClick = function()
        SelectionContainerPopOutBorder:SetVisible(not(SelectionContainerPopOutBorder:IsVisible()))
    end


    local SelectionLabel = Turbine.UI.Label()
    SelectionLabel:SetParent(SelectionContainer)
    SelectionLabel:SetPosition(0, 0)
    SelectionLabel:SetSize(400 - 10, 40 - 10)
    SelectionLabel:SetMouseVisible(false)
    --SelectionLabel:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))
    SelectionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    SelectionLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
    SelectionLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    SelectionLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    SelectionLabel:SetText("Select Parse To Analyse")

    local PopOoutContainer = Turbine.UI.ListBox()
    PopOoutContainer:SetParent(SelectionContainerPopOut)
    PopOoutContainer:SetSize(380, 230)
    PopOoutContainer:SetPosition(0, 0)
    PopOoutContainer:SetVisible(true)
    --PopOoutContainer:SetBackColor(GetRandomColour())
    PopOoutContainer:SetOrientation( Turbine.UI.Orientation.Vertical );

    local ScrollbarBackground = Turbine.UI.Control()
    ScrollbarBackground:SetParent( SelectionContainerPopOut );
    ScrollbarBackground:SetPosition( 380, 0 );
    ScrollbarBackground:SetSize( 10, 230);
    ScrollbarBackground:SetMouseVisible(false)
    ScrollbarBackground:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))

    local PopOoutContainerScrollbar = Turbine.UI.Lotro.ScrollBar();
    PopOoutContainerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical );
    PopOoutContainerScrollbar:SetParent( SelectionContainerPopOut );
    PopOoutContainerScrollbar:SetPosition( 380, 0 );
    PopOoutContainerScrollbar:SetSize( 10, 230);
    PopOoutContainerScrollbar:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))
    PopOoutContainer:SetVerticalScrollBar( PopOoutContainerScrollbar );

    self.AddTimestampEntry = function(Time, TimeString, HighestTarget)

        if HighestTarget == nil then return end

        local ListItem = Turbine.UI.Control()
        ListItem:SetSize(380, 34)
        ListItem:SetMouseVisible(true)
        ListItem:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))

        local BackGroundControl = Turbine.UI.Control()
        BackGroundControl:SetParent(ListItem)
        BackGroundControl:SetSize(380, 30)
        BackGroundControl:SetPosition(0, 2)
        BackGroundControl:SetMouseVisible(false)
        BackGroundControl:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))

        local NameLabel = Turbine.UI.Label()
        NameLabel:SetParent(ListItem)
        NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        NameLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
        NameLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        NameLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
        NameLabel:SetSize(380, 30)
        NameLabel:SetPosition(0, 2)
        NameLabel:SetMouseVisible(false)
        NameLabel:SetMultiline(false)
        NameLabel:SetText(HighestTarget .." (" .. TimeString .. ")")

        local StartTime = Time
        
        ListItem.MouseClick = function()
            self.ClearStatWindows()
            self.SetupStatWindows(StartTime)
            SelectionContainerPopOutBorder:SetVisible(false)
        end

        ListItem.MouseEnter = function()
            BackGroundControl:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))
        end

        ListItem.MouseLeave = function()
            BackGroundControl:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))
        end

        PopOoutContainer:AddItem(ListItem)
    end

    self.CombatChanged()
end
