

--[[
function TableToString(Table, TableName, Indent)

    local OutputString = string.rep( " ", Indent * 4 ) .. "[" .. HandleValueType(TableName) .. "] = \n" .. string.rep( " ", Indent * 4 )  .."{\n"

    for key, value in pairs(Table) do
        if type(value) == "table" then
            OutputString = OutputString .. string.rep( " ", (Indent) * 4) .. TableToString(value, key, Indent + 1)
        else            
            OutputString = OutputString .. string.rep( " ", (Indent + 1) * 4) .. "[" .. HandleValueType(key) .. "] = " .. HandleValueType(value) .. ",\n"
        end
    end

    OutputString = OutputString .. string.rep( " ", (Indent) * 4)  .. "},\n"

    return OutputString
end

--]]
function HandleValueType(Value)
    local ValueType = type(Value)

    if ValueType == "number" then
        return Value
    elseif ValueType == "string" then
        return ("\"" .. Value .. "\"")
    elseif Value == nil then
        return ""
    end
end

function tablelength(T)
    local count = 0
    if T ~= nil and type(T) == "table" then
        for _ in pairs(T) do count = count + 1 end
    end
    return count
end

NestTestTable = {
    [7] = 9,
    [10] = "11",

}

TestTable = {
    [5] = "Testing", 
    [6] = 7,
    --["Test"] = NestTestTable
}

-- [[
function TableToString(T, TableName)
    local OutputString = "Table start: " .. TableName .. "-;"

    --ChatOutput(TableName)
    for key, value in pairs(T) do
        --ChatOutput(key)
        --ChatOutput(value)
        OutputString = OutputString .. HandleValueType(key) .. "=" .. HandleValueType(value) .. ";"
    end

    OutputString = OutputString .. "Table End: " .. TableName .. "|"

    ChatOutput(OutputString)
    return OutputString
end
--]]

function StringToTable(InputString)

    local OutputTable = {}
    for TableString in string.gmatch(InputString, "([^|]+)") do
        local TableName = string.match(TableString, "Table start: (.+)-")
        --ChatOutput(TableName)

        OutputTable[TableName] = {}
        for string in string.gmatch(TableString, "([^;]+)") do
            if string.find(string, "Table End") then break end
            if not(string.find(string, "Table start:")) then
                local key, value = string.match(string, "(.*)=(.*)")
                OutputTable[TableName][key] = value
            end
        end
    end

    return OutputTable
end

--Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Target, false );
--ChatOutput(type(TestTable))
--ChatOutput("\n" .. TableToString(TestTable, "DPSMapped", 0) .. TableToString(TestTable, "DPSMapped", 0))
--StringToTable(TableToString(TestTable, "DPSMapped"))

--[[
for key, value in pairs( StringToTable(TableToString(TestTable, "DPSMapped", 0) .. TableToString(TestTable, "Test", 0))) do
    ChatOutput(key)
    for key2, value2 in pairs(value) do
        ChatOutput(key2)
        ChatOutput(value2)
    end
end
--]]