PartyWindow = class( Turbine.UI.Window)
function PartyWindow:Constructor()
    Turbine.UI.Window.Constructor( self );

    local player = Turbine.Gameplay.LocalPlayer.GetInstance()

    local Party = player:GetParty()

    self.VitalWindows = {}

    self:SetPosition(Settings.VX, Settings.VY)
    self:SetVisible(true)
    --self:SetBackColor(Turbine.UI.Color(0,0,0))

    self.Setup = Settings.FrameVersion

    if Party == nil then return end 

    if self.Setup == 1 then
        -- Big setup vertical
        self:SetSize(154 * math.ceil(Party:GetMemberCount() / 6), math.min(Party:GetMemberCount(), 6) * 94 )

        for i = 1, Party:GetMemberCount(), 1 do
            self.VitalWindows[Party:GetMember(i):GetName()] = VitalWindow(self, Party:GetMember(i), math.floor((i - 1) / 6), (i - 1) % 6, 150, 90, 5, 23, 2)
        end

    elseif self.Setup == 2 then
        -- Big setup horizontal
        self:SetSize(154 * math.min(Party:GetMemberCount(), 6), math.ceil(Party:GetMemberCount() / 6) * 94 )

        for i = 1, Party:GetMemberCount(), 1 do
            self.VitalWindows[Party:GetMember(i):GetName()] = VitalWindow(self, Party:GetMember(i), (i - 1) % 6, math.floor((i - 1) / 6), 150, 90, 5, 23, 2)
        end

    elseif self.Setup == 3 then

        -- Minimalist Setup
        self:SetSize(254, Party:GetMemberCount() * 32 )

        for i = 1, Party:GetMemberCount(), 1 do
            self.VitalWindows[Party:GetMember(i):GetName()] = VitalWindow(self, Party:GetMember(i), 0, i - 1, 150, 28, 152, 0, 1)
        end
    end

    self.moveBox = MoveBox(self, self:GetWidth(), self:GetHeight(), "Party Vitals")

    player.TargetChanged = function(sender, args)
        if self.CurrentlySelected and self.VitalWindows[self.CurrentlySelected] then self.VitalWindows[self.CurrentlySelected]:Select(false) end 
        if player:GetTarget() then 
            if self.VitalWindows[player:GetTarget():GetName()] then 
                self.VitalWindows[player:GetTarget():GetName()]:Select(true) 
                self.CurrentlySelected = player:GetTarget():GetName()
            end
            self.CurrentlySelected = player:GetTarget():GetName()
        else
            self.CurrentlySelected = nil
        end
    end
end

function PartyWindow:Move()
    self.moveBox:ToggleMove()
end
