VitalWindow = class( Turbine.UI.Control)
function VitalWindow:Constructor(parent, player, indexX, indexY, vitalWidth, vitalHeight, effectX, effectY, effectVersion)
    Turbine.UI.Control.Constructor( self );
	
    --self.layout = Turbine.UI.HorizontalLayout.LeftToRight;
    local width = 0
    if (effectX + 100) - vitalWidth > 0 then width = vitalWidth + ((effectX + 100) - vitalWidth) + 4 else width = vitalWidth + 4 end

    --ChatOutput(effectMarginX)

    --local width = vitalWidth + 4 + 100
    local height = vitalHeight + 4

    local effectMarginX = math.max(vitalWidth - (effectX + 100), width)

    --ChatOutput(indexX)
    --ChatOutput(indexY)
	
    self:SetParent(parent)
    self:SetPosition( indexX * (width - 2), indexY * height );
    self:SetSize( width, height);
    self:SetVisible(true)
    self:SetMouseVisible(false)

    self.BuffBoxes = {}

    self.UpdateCountdown = Settings.ShowCountdown

    self.IconScale = Settings.IconScale
    self.IconSize = 29

    self.IconRow = 0
    self.IconRowHeight = 160 - self.IconSize

    self.player = player
    --self.ClassAttr = self.player:GetClassAttributes()
    --self.ClassType = self.player:GetClass()


    self.EffectPosition = Settings.EffectVersion

    self.EffectIDs = {}
    self.EffectCount = {}
    self.EffectBoxesByName = {}

    self.oldGameTime = Turbine.Engine.GetGameTime()

    local offset = 0

    if self.ClassType == Turbine.Gameplay.Class.Champion or 
    self.ClassType == Turbine.Gameplay.Class.Hunter or 
    self.ClassType == Turbine.Gameplay.Class.RuneKeeper then
        offset = 20
    end

    
    --[[
	self.nameLabel = Turbine.UI.Label();
	self.nameLabel:SetParent( self );
	self.nameLabel:SetPosition( 60, 3 );
	self.nameLabel:SetSize( 160, 12 );
	self.nameLabel:SetFontStyle( Turbine.UI.FontStyle.Outline );
	self.nameLabel:SetOutlineColor( Turbine.UI.Color( 0, 0, 0 ) );
	self.nameLabel:SetMouseVisible( false );
    --]]
    
	self.vitalsFrame = Turbine.UI.Control();
	self.vitalsFrame:SetParent( self );
	self.vitalsFrame:SetBackColor( Turbine.UI.Color(0, 0, 0 ) );
	self.vitalsFrame:SetPosition( 0, 0 );
	self.vitalsFrame:SetSize( vitalWidth + 4, vitalHeight + 4);	
    self.vitalsFrame:SetMouseVisible( true );	
    self.vitalsFrame:SetPosition(0, 0)
    --self.vitalsFrame:SetBackColor(Turbine.UI.Color(0.125,0.125,0.125))

    self.E = Turbine.UI.Lotro.EntityControl()
    self.E:SetParent (self.vitalsFrame)
    self.E:SetVisible (true)
    self.E:SetSize(width, height)
    self.E:SetEntity(self.player)
	
	-- Construct the morale bar.
	self.moraleBar = VitalBar(vitalWidth, vitalHeight - 5, true, "");
    self.moraleBar:SetParent( self.vitalsFrame );
    self.moraleBar:SetPosition(2, 2)
    local colour = nil
    if Settings.ColourMode == 1 then 
        colour = ClassColours[self.player:GetClass()]
    elseif Settings.ColourMode == 2 then
        colour = Turbine.UI.Color(0.4, 0.7, 0.1)
    end
    self.moraleBar:SetColours(Turbine.UI.Color(0.375, 0.375, 0.375), colour, Turbine.UI.Color(179/255, 0, 224/255), Turbine.UI.Color(1.0, 0.4, 0))
	--self.moraleBar:SetColor( Turbine.UI.Color( 1, 0.1, 1, 0.1 ) );
	--self.moraleBar:SetBuffColor( Turbine.UI.Color( 1, 0.3, 0.7, 1 ) );
	--self.moraleBar:SetDebuffColor( Turbine.UI.Color( 1, 1.0, 0.4, 0 ) );
	--self.moraleBar:SetPosition( 60, 19 );
	self.moraleBar:SetMouseVisible( false );
	--self.moraleBar:SetShowPercentage( true );
    --self.moraleBar:SetHorizontalLayout( Turbine.UI.HorizontalLayout.RightToLeft );
	
    --self.SetText( self.moraleBar, "This is a really bad thing to be doing. I'm passing the wrong type of control..." );

	
    -- Construct the power bar.
	self.powerBar = VitalBar(vitalWidth, 5, false);
	self.powerBar:SetParent( self.vitalsFrame );
    self.powerBar:SetZOrder( 100 );
    if self.ClassType == Turbine.Gameplay.Class.Beorning then
        self.powerBar:SetColours(Turbine.UI.Color(40/255, 0, 0), Turbine.UI.Color(100/255, 0, 0), Turbine.UI.Color(179/255, 0, 224/255), Turbine.UI.Color(1.0, 0.4, 0))
    else
        self.powerBar:SetColours(Turbine.UI.Color(0.1, 0.4, 0.4), Turbine.UI.Color(0.1, 0.1, 0.7), Turbine.UI.Color(179/255, 0, 224/255), Turbine.UI.Color(1.0, 0.4, 0))
    end
	--self.powerBar:SetColor( Turbine.UI.Color( 1, 0.1, 0.5, 1 ) );
	self.powerBar:SetPosition( 2, vitalHeight - 5 + 2 );
    self.powerBar:SetMouseVisible( false );

    self.icon = Turbine.UI.Control()
    self.icon:SetParent(self)
    self.icon:SetBlendMode(Turbine.UI.BlendMode.Overlay )
    self.icon:SetBackground(Icons[self.player:GetClass()])
    self.icon:SetSize(20, 20)
    self.icon:SetPosition(2, 2)

    self.text = Turbine.UI.Label()
    self.text:SetParent( self )
    self.text:SetForeColor( Turbine.UI.Color( 1, 1, 1, 1 ) )
    self.text:SetOutlineColor( Turbine.UI.Color( 1, 0, 0, 0 ) )
    self.text:SetFontStyle( Turbine.UI.FontStyle.Outline )
    self.text:SetFont( Turbine.UI.Lotro.Font.BookAntiquaBold19 )
    self.text:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft )
    self.text:SetZOrder( 100 )
    self.text:SetSize(vitalWidth, 20)
    self.text:SetMouseVisible(false)
    self.text:SetText(" " .. self.player:GetName())
    self.text:SetPosition(20, 0)

    self.player.MoraleChanged = function( sender, args )
        self.moraleBar:SetCurrentValueImmediate( self.player:GetMorale() )
	end
	
	self.player.MaxMoraleChanged = function( sender, args )
		self.moraleBar:SetMaxValue( self.player:GetMaxMorale() )
	end
	
	self.player.BaseMaxMoraleChanged = function( sender, args )
		self.moraleBar:SetMaxValue( self.player:GetMaxMorale() )
    end

    self.player.TemporaryMoraleChanged = function( sender, args )
		self.moraleBar:SetTempValue(self.player:GetTemporaryMorale())
	end
	
    self.player.MaxTemporaryMoraleChanged = function( sender, args )
        self.moraleBar:SetMaxTempValue(self.player:GetMaxTemporaryMorale())
	end
    
    self.player.PowerChanged = function( sender, args )
        self.powerBar:SetCurrentValue( self.player:GetPower() )
    end
    
    self.player.MaxPowerChanged = function( sender, args )
        self.powerBar:SetMaxValue( self.player:GetMaxPower() )
    end
    
    self.player.BaseMaxPowerChanged = function( sender, args )
        self.powerBar:SetMaxValue( self.player:GetMaxPower() )
    end


    self.moraleBar:SetCurrentValue( self.player:GetMorale() )
    self.moraleBar:SetMaxValue( self.player:GetMaxMorale() )
    self.moraleBar:SetMaxValue( self.player:GetMaxMorale() )
    self.moraleBar:SetTempValue(self.player:GetTemporaryMorale())
    self.moraleBar:SetMaxTempValue(self.player:GetMaxTemporaryMorale())

    if self.ClassType == Turbine.Gameplay.Class.Beorning then
        self.powerBar:SetCurrentValue( self.ClassAttr:GetWrath() )
        self.powerBar:SetMaxValue( 100 )
        self.powerBar:SetMaxValue( 100 )
    else
        self.powerBar:SetCurrentValue( self.player:GetPower() )
        self.powerBar:SetMaxValue( self.player:GetMaxPower() )
        self.powerBar:SetMaxValue( self.player:GetMaxPower() )
    end

    self.Moving = false
  
    self.E.MouseMove = function(sender,args)
        if self.Moving then
            local newLeft = self:GetLeft() - (self.MoveX - args.X)
            local newTop = self:GetTop() - (self.MoveY - args.Y)
            self:SetPosition(newLeft,newTop)
        end
    end

    self.buffBox = Turbine.UI.Control();
    self.buffBox:SetParent( self );
    --self.buffBox:SetBackColor( Turbine.UI.Color( 1, 0, 0, 0 ) );
    if effectVersion == 1 then 
        self.buffBox:SetSize( 100, 30 );	
    else
        self.buffBox:SetSize( 100, 60 );	
    end
    self.buffBox:SetMouseVisible( false );	
    self.buffBox:SetPosition(effectX, effectY)
    --self.buffBox:SetBackColor(Turbine.UI.Color(0,0,0))


    -- Effects
    -- [[
    local effectList = self.player:GetEffects()

    for i = 1, effectList:GetCount(), 1 do
        local effect =  effectList:Get(i)
        self.EffectIDs[effect:GetID()] = true
        if EffectIcons[effect:GetName()] then
            self.BuffBoxes[effect:GetID()] = EffectBox(self.buffBox, effect, self.IconSize)

            if self.EffectCount[effect:GetName()] then
                self.EffectCount[effect:GetName()] = self.EffectCount[effect:GetName()] + 1
            else
                self.EffectCount[effect:GetName()] = 1
            end

            self.BuffResort = true
        end
    end 

    self.player:GetEffects().EffectAdded = function(sender, args)
        local effect = self.player:GetEffects():Get(args.Index)
        if not(self.EffectIDs[effect:GetID()]) then
            self.EffectIDs[effect:GetID()] = true
            if EffectIcons[effect:GetName()] then
                self.BuffBoxes[effect:GetID()] = EffectBox(self.buffBox, effect, self.IconSize)

                if self.EffectCount[effect:GetName()] then
                    self.EffectCount[effect:GetName()] = self.EffectCount[effect:GetName()] + 1
                else
                    self.EffectCount[effect:GetName()] = 1
                end
                
                if self.EffectCount[effect:GetName()] > EffectIcons[effect:GetName()] then
                    local duration = 99999999999
                    local idToRemove = 0
                    for key, value in pairs(self.BuffBoxes) do
                        if value:GetName() == effect:GetName() then
                            if value:GetValue() < duration then 
                                duration = value:GetValue() 
                                idToRemove = key
                            end
                        end
                    end
    
                    self.BuffBoxes[idToRemove]:SetVisible(false) 
                    self.BuffBoxes[idToRemove]:SetParent(nil) 
                    self.BuffBoxes[idToRemove] = nil
                    self.EffectCount[effect:GetName()] = self.EffectCount[effect:GetName()] - 1
    
                end

                self.BuffResort = true
            end
        end
    end
    --]]

    self.Update = function()
        local currentGameTime = Turbine.Engine.GetGameTime()
        if currentGameTime == self.oldGameTime then
            return(true)
        end
        local delta = currentGameTime - self.oldGameTime
        for key, value in pairs(self.BuffBoxes) do
            value:UpdateText(delta)
            -- [[
            if value:GetValue() < 0 then
                self.EffectCount[value:GetName()] = self.EffectCount[value:GetName()] - 1
                value:SetVisible(false) 
                value:SetParent(nil) 
                self.BuffBoxes[key] = nil
                self.BuffResort = true
            end
            --]]
        end

        if self.BuffResort then self.ResortList() end

        self.oldGameTime = currentGameTime
    end

    self.ResortList = function()
        if self.BuffResort then
            local counter = 0
            for _,v in spairs(self.BuffBoxes, function(t,a,b) return t[b]:GetValue() < t[a]:GetValue() end) do
                v:SetPosition((counter % 3)  * self.IconSize, math.floor(counter / 3) * self.IconSize)
                counter = counter + 1
            end
            self.BuffResort = false
        end
    end

    self:ResortList()
    self:SetWantsUpdates(true)
end

function VitalWindow:Select(selected) 
    if selected then 
        self.vitalsFrame:SetBackColor(Turbine.UI.Color(0.2,1,0.2)) 
        self:SetZOrder(100)
    else 
        self.vitalsFrame:SetBackColor(Turbine.UI.Color(0.125,0.125,0.125)) 
        self:SetZOrder(99)
    end
end