SkillOverlayOptions = class(Turbine.UI.Control)
function SkillOverlayOptions:Constructor(parent)
    local width = Settings.LOWidth
    local height = 500
    local x = Settings.LOX
    local y = Settings.LOY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Control.Constructor(self);
    self:SetParent(parent)
    self:SetSize(width,height); -- sets the window size to 200 by 200 pixels
    self:SetPosition(0,0);
    --self:SetWantsKeyEvents(true)
    self:SetVisible(false)    

    local menu = Turbine.UI.ContextMenu()
    local menuItems = menu:GetItems()

    local tskills = Player:GetTrainedSkills()
    local counter = 0

    local currentlySelectedItem = nil
    local SkillDictionary = {}
    local LocalSkillBars = {}
    local SkillsByNames = {}

    local itemSelectedLabel = Turbine.UI.Label()
    itemSelectedLabel:SetParent(self)
    itemSelectedLabel:SetSize(30, 30)
    itemSelectedLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    itemSelectedLabel:SetMouseVisible(false)
    itemSelectedLabel:SetPosition(60, 100)

    local skillSelected = Turbine.UI.Label()
    skillSelected:SetParent(self)
    skillSelected:SetSize(100, 30)
    skillSelected:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    skillSelected:SetMouseVisible(false)
    skillSelected:SetPosition(220, 100)

    local infoLabel = Turbine.UI.Label()
    infoLabel:SetSize(500, 40)
    infoLabel:SetPosition(0, 0)
    infoLabel:SetParent(self)
    infoLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold16)
    infoLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    infoLabel:SetOutlineColor(OutlineColor)
    infoLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    infoLabel:SetVisible(true)
    infoLabel:SetText("Select a box that corresponds to the position on your skill bar. Then use the select skill button to bind a skill to that box. If you want to remove a skill there is an option at the bottom of the list.")

    local removeLabel = Turbine.UI.Label()
    removeLabel:SetSize(600, 40)
    removeLabel:SetPosition(180, 160)
    removeLabel:SetParent(self)
    removeLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    removeLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    removeLabel:SetOutlineColor(OutlineColor)
    removeLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    removeLabel:SetForeColor(Turbine.UI.Color(1, 0,0))
    removeLabel:SetVisible(false)
    removeLabel:SetText("Reload the plugin to activate skillbars (you can move them already)")

    for i = 1, Player:GetTrainedSkills():GetCount(), 1 do
        local item = tskills:GetItem(i)--:GetSkillInfo()
        local name = item:GetSkillInfo():GetName() 
        local description = item:GetSkillInfo():GetDescription()

        if (not(RealSkill(description))and string.len(description) > 0 and item:GetSkillInfo():GetType() ~= 1) then
            SkillsByNames[name] = item
        end
    end

    local SelectionContainerPopOutBorder = Turbine.UI.Control()
    SelectionContainerPopOutBorder:SetParent(self)
    SelectionContainerPopOutBorder:SetPosition(200 - 5, 90 - 5)
    SelectionContainerPopOutBorder:SetSize(400, 240)
    SelectionContainerPopOutBorder:SetMouseVisible(false)
    SelectionContainerPopOutBorder:SetVisible(false)
    SelectionContainerPopOutBorder:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))
    SelectionContainerPopOutBorder:SetZOrder(100)

    local SelectionContainerPopOut = Turbine.UI.Control()
    SelectionContainerPopOut:SetParent(SelectionContainerPopOutBorder)
    SelectionContainerPopOut:SetPosition(5, 5)
    SelectionContainerPopOut:SetSize(400 - 10, 240 - 10)
    SelectionContainerPopOut:SetMouseVisible(true)
    SelectionContainerPopOut:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))
    SelectionContainerPopOut:SetZOrder(100)

    local PopOoutContainer = Turbine.UI.ListBox()
    PopOoutContainer:SetParent(SelectionContainerPopOut)
    PopOoutContainer:SetSize(380, 230)
    PopOoutContainer:SetPosition(0, 0)
    PopOoutContainer:SetVisible(true)
    --PopOoutContainer:SetBackColor(GetRandomColour())
    PopOoutContainer:SetOrientation( Turbine.UI.Orientation.Vertical );

    local ScrollbarBackground = Turbine.UI.Control()
    ScrollbarBackground:SetParent( SelectionContainerPopOut );
    ScrollbarBackground:SetPosition( 380, 0 );
    ScrollbarBackground:SetSize( 10, 230);
    ScrollbarBackground:SetMouseVisible(false)
    ScrollbarBackground:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))

    local PopOoutContainerScrollbar = Turbine.UI.Lotro.ScrollBar();
    PopOoutContainerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical );
    PopOoutContainerScrollbar:SetParent( SelectionContainerPopOut );
    PopOoutContainerScrollbar:SetPosition( 380, 0 );
    PopOoutContainerScrollbar:SetSize( 10, 230);
    PopOoutContainerScrollbar:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))
    PopOoutContainer:SetVerticalScrollBar( PopOoutContainerScrollbar );


    local sortedKeys = {}
    for key, value in pairs(SkillsByNames) do table.insert( sortedKeys, key ) end
    table.sort( sortedKeys )
    
    for key, name in pairs(sortedKeys) do
        local item = SkillsByNames[name]
        local menuItem = Turbine.UI.MenuItem( name )

        local ListItem = Turbine.UI.Control()
        ListItem:SetSize(380, 34)
        ListItem:SetMouseVisible(true)
        ListItem:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))

        local BackGroundControl = Turbine.UI.Control()
        BackGroundControl:SetParent(ListItem)
        BackGroundControl:SetSize(380, 30)
        BackGroundControl:SetPosition(0, 2)
        BackGroundControl:SetMouseVisible(false)
        BackGroundControl:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))

        local NameLabel = Turbine.UI.Label()
        NameLabel:SetParent(ListItem)
        NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        NameLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
        NameLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        NameLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
        NameLabel:SetSize(380, 30)
        NameLabel:SetPosition(0, 2)
        NameLabel:SetMouseVisible(false)
        NameLabel:SetText(name)
        
        ListItem.MouseClick = function()
            if currentlySelectedItem ~= nil then
                skillSelected:SetText(name) 
                SkillDictionary[tonumber(currentlySelectedItem:GetText())] = item
                currentlySelectedItem:SetBackColor()
                currentlySelectedItem:SetBackground(item:GetSkillInfo():GetIconImageID())
             end
             SelectionContainerPopOutBorder:SetVisible(false)
        end

        ListItem.MouseEnter = function()
            BackGroundControl:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))
        end

        ListItem.MouseLeave = function()
            BackGroundControl:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))
        end

        PopOoutContainer:AddItem(ListItem)
    end

    local ListItem = Turbine.UI.Control()
    ListItem:SetSize(380, 34)
    ListItem:SetMouseVisible(true)
    ListItem:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))

    local BackGroundControl = Turbine.UI.Control()
    BackGroundControl:SetParent(ListItem)
    BackGroundControl:SetSize(380, 30)
    BackGroundControl:SetPosition(0, 2)
    BackGroundControl:SetMouseVisible(false)
    BackGroundControl:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))

    local NameLabel = Turbine.UI.Label()
    NameLabel:SetParent(ListItem)
    NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    NameLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
    NameLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    NameLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    NameLabel:SetSize(380, 30)
    NameLabel:SetPosition(0, 2)
    NameLabel:SetMouseVisible(false)
    NameLabel:SetText("Remove skill")
    
    ListItem.MouseClick = function()
        if currentlySelectedItem ~= nil then
            skillSelected:SetText("") 
            SkillDictionary[tonumber(currentlySelectedItem:GetText())] = ""
            currentlySelectedItem:SetBackColor(GetRandomColour())
         end
         SelectionContainerPopOutBorder:SetVisible(false)
    end

    ListItem.MouseEnter = function()
        BackGroundControl:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))
    end

    ListItem.MouseLeave = function()
        BackGroundControl:SetBackColor(Turbine.UI.Color(0.375, 0.375, 0.375))
    end

    PopOoutContainer:AddItem(ListItem)
    

    self.MakeSkillBox = function(index)
        local skillLabel = Turbine.UI.Label()
        skillLabel:SetParent(self)
        skillLabel:SetPosition(30 + 35 * index, 50)
        skillLabel:SetSize(32, 32)
        skillLabel:SetText(index)
        skillLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        skillLabel:SetBackColor(GetRandomColour())
        skillLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
        skillLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        skillLabel:SetOutlineColor(OutlineColor)
        SkillDictionary[index] = ""

        skillLabel.MouseClick = function()
            itemSelectedLabel:SetText(index)
            currentlySelectedItem = skillLabel
            if SkillDictionary[index] ~= "" then
                skillSelected:SetText(SkillDictionary[index]:GetSkillInfo():GetName())
            else
                skillSelected:SetText("")
            end
        end
    end

    for i = 1, 12 do
        self.MakeSkillBox(i)
    end

    
    local SkillButton = Turbine.UI.Lotro.Button()
    SkillButton:SetParent(self)
    SkillButton:SetSize(100, 15)
    SkillButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    SkillButton:SetMouseVisible(false)
    SkillButton:SetPosition(90, 104)
    SkillButton:SetText("Select skill")

    SkillButton.Click = function()
        --menu:ShowMenu()
        SelectionContainerPopOutBorder:SetVisible(not(SelectionContainerPopOutBorder:IsVisible()))
    end

    local NameBox = Turbine.UI.Lotro.TextBox()
    NameBox:SetParent(self)
    NameBox:SetSize(150, 30)
    NameBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    NameBox:SetPosition(400, 104)
    NameBox:SetText("<Enter Name>")

    local BarButton = Turbine.UI.Lotro.Button()
    BarButton:SetParent(self)
    BarButton:SetSize(100, 30)
    BarButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    BarButton:SetMouseVisible(false)
    BarButton:SetPosition(430, 140)
    BarButton:SetText("Create Bar")

    BarButton.Click = function()
        local name = NameBox:GetText()
        if name ~= "" and LocalSkillBars[name] == nil and SkillBars[name] == nil then
            LocalSkillBars[name] = SkillDictionary
            SkillBars[name] = {}
            for key, value in pairs(SkillDictionary) do
                if value.GetSkillInfo then
                    SkillBars[name][key] =  value:GetSkillInfo():GetName()
                end
            end
            CreateSkillBars(LocalSkillBars)
            removeLabel:SetVisible(true)
            LocalSkillBars = {}            
        else
            ChatOutput("No name or already existing name for bar!")
        end
    end

    local MoveButton = Turbine.UI.Lotro.Button()
    MoveButton:SetParent(self)
    MoveButton:SetSize(100, 30)
    MoveButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    MoveButton:SetMouseVisible(false)
    MoveButton:SetPosition(530, 140)
    MoveButton:SetText("Move Bars")

    MoveButton.Click = function()
        MoveActionBars()
    end

    self.MakeSkillBoxForShow = function(index, icon, parent)
        local skillLabel = Turbine.UI.Label()
        skillLabel:SetParent(parent)
        skillLabel:SetPosition(100 + 35 * index, 3)
        skillLabel:SetSize(32, 32)
        skillLabel:SetText(index)
        skillLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        if icon == nil then
            skillLabel:SetBackColor(GetRandomColour())
        else
            skillLabel:SetBackground(icon)
        end
        skillLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
        skillLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        skillLabel:SetOutlineColor(OutlineColor)
    end

    self.CreateShowBar = function(value, listItem)
        for index, skillName in pairs(value) do
            local skill = SkillsByNames[skillName]
            if skill ~= nil then 
                self.MakeSkillBoxForShow(index, skill:GetSkillInfo():GetIconImageID(), listItem)
            else
                self.MakeSkillBoxForShow(index, nil, listItem)
            end
        end
    end

    
    local blablaLabel = Turbine.UI.Label()
    blablaLabel:SetSize(200, 40)
    blablaLabel:SetPosition(30, 170)
    blablaLabel:SetParent(self)
    blablaLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    blablaLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    blablaLabel:SetOutlineColor(OutlineColor)
    blablaLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    blablaLabel:SetText("Existing Action Bars:")

    if Tablelength(SkillBars) <= 0 then
        blablaLabel:SetVisible(false)
    end


    -- Show existing bars
    local listbox = Turbine.UI.ListBox();
    listbox:SetParent( self );
    --listbox:SetBackColor( Turbine.UI.Color( 0.2, 0.2, 0.2 ) );
    listbox:SetPosition( 30, 200 );
    listbox:SetSize( 700, 240 );

    for key, value in pairs(SkillBars) do
        local listItem = Turbine.UI.Control();
        listItem:SetBackColor( GetRandomColour() );

        local nameLabel = Turbine.UI.Label()
        nameLabel:SetSize(100, 40)
        nameLabel:SetParent(listItem)
        nameLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
        nameLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        nameLabel:SetOutlineColor(OutlineColor)
        nameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        nameLabel:SetText(key)

        listItem:SetSize( 700, 40 );
        self.CreateShowBar(value, listItem)
        listbox:AddItem( listItem );

        local removeButton = Turbine.UI.Lotro.Button()
        removeButton:SetParent(listItem)
        removeButton:SetSize(100, 30)
        removeButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        removeButton:SetMouseVisible(false)
        removeButton:SetPosition(100 + 35 * 13, 10)
        removeButton:SetText("Remove Bar")

        removeButton.Click = function()
            ActiveSkillBars[key]:SetVisible(false)
            ActiveSkillBars[key]:SetParent(nil)            
            ActiveSkillBars[key] = nil
            SkillBarsPositions[key] = nil
            SkillBars[key] = nil
            --CreateSkillBars(LocalSkillBars)
            listItem:SetVisible(false)
        end
    end

    -- Scaling
    local ScaleBox = Turbine.UI.Lotro.TextBox()
    ScaleBox:SetParent(self)
    ScaleBox:SetSize(50, 30)
    ScaleBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    ScaleBox:SetPosition(550, 4)
    ScaleBox:SetText(Settings.SkillbarScale)

    local ScaleButton = Turbine.UI.Lotro.Button()
    ScaleButton:SetParent(self)
    ScaleButton:SetSize(100, 30)
    ScaleButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    ScaleButton:SetMouseVisible(false)
    ScaleButton:SetPosition(630, 10)
    ScaleButton:SetText("Set Scale")

    ScaleButton.Click = function()
        if ScaleBox:GetText() ~= "" and ScaleBox:GetText() ~= nil and ScaleBox:GetText() ~= Settings.SkillbarScale then
            ChatOutput(ScaleBox:GetText())
            Settings.SkillbarScale = tonumber(ScaleBox:GetText())
        end
    end

    local cBox = Turbine.UI.Lotro.CheckBox();
    cBox:SetParent(self)
    cBox:SetPosition(550, 54);
    cBox:SetSize(200, 20);
    cBox:SetChecked(Settings.SkillbarPopups)
    cBox:SetText("Enable CD popups");
    cBox:SetVisible(true);

    cBox.CheckedChanged = function(sender,args)
        Settings.SkillbarPopups = cBox:IsChecked()
    end


    -- CD threshold
    local ScaleBox = Turbine.UI.Lotro.TextBox()
    ScaleBox:SetParent(self)
    ScaleBox:SetSize(50, 30)
    ScaleBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    ScaleBox:SetPosition(550, 104)
    ScaleBox:SetText(Settings.SkilloverlayCDThreshold)

    local ScaleButton = Turbine.UI.Lotro.Button()
    ScaleButton:SetParent(self)
    ScaleButton:SetSize(100, 30)
    ScaleButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    ScaleButton:SetMouseVisible(false)
    ScaleButton:SetPosition(630, 110)
    ScaleButton:SetText("Popup threshold")

    ScaleButton.Click = function()
        if ScaleBox:GetText() ~= "" and ScaleBox:GetText() ~= nil and ScaleBox:GetText() ~= Settings.SkilloverlayCDThreshold then
            ChatOutput(ScaleBox:GetText())
            Settings.SkilloverlayCDThreshold = tonumber(ScaleBox:GetText())
        end
    end
end

function RealSkill(description)
    for key, _ in pairs(ForbiddenSkills) do
        if string.find(description, key) then return true end
    end
    return false
end

ForbiddenSkills = {
    ["Allows the Warden to travel"] = true,
    ["goat"] = true,
    ["horse"] = true,
    ["Brings out"] = true,
    ["steed"] = true,
    ["Summons"] = true,
    ["This is a fleet-footed goat"] = true,
    ["A mighty Lasgalen elk"] = true,
    ["This skill suppresses all mount speed buffs"] = true,
    ["A favourite toy"] = true,
    ["A brightly coloured theme sets"] = true,
    ["Black as the night"] = true,
    ["Swallow this potion"] = true,
    ["This is probably the best snowball"] = true,
    ["An elite goat"] = true,
    ["Return quickly"] = true,
    ["Elk"] = true,
    ["Journey to the"] = true,
    ["Rescued from the cruelty of Lhaereth."] = true,
    ["return to"] = true,
    ["stag"] = true,
    ["pig"] = true,
    ["cow"] = true,
    ["sheep"] = true,
    ["deer"] = true,
    ["Toad"] = true,
    ["This black silk glove"] = true,
    ["A winged companion."] = true,
    ["Bill the Pony."] = true,
    ["he provides pleasant company"] = true,
    ["A token of thanks"] = true,
    ["Soldier"] = true,
    ["to ride alongside of you."] = true,
    ["A violent strike against the target that focuses on your offensive capability, dealing damage and increasing threat against the target."] = true,
    ["Skill of the Eorlingas becomes Halt the Charge."] = true,
    ["Return quickly"] = true,
    ["on the radar"] = true,
    ["Herald to carry"] = true,
    ["Archer to assist"] = true,
}

function CreateSkillBars(skillBar)
    for name, bar in pairs(skillBar) do
        ActiveSkillBars[name] =  SkillBar(bar, name)
    end
end

SkillBar = class(Turbine.UI.Window)
function SkillBar:Constructor(SkillList, name)
    local positions = SkillBarsPositions[name]
    local x = 0
    local y = 0
    if positions == nil then
        x = Settings.LOX
        y = Settings.LOY
    else
        x = positions[1]
        y = positions[2]
    end
    local width = 35 * ScaleX * 12
    local height = 32 * ScaleY
    local font = Settings.LOFont
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Window.Constructor(self);
    self:SetSize(width, height); -- sets the window size to 200 by 200 pixels
    self:SetPosition(x,y);
    self:SetVisible(true)
    self:SetMouseVisible(false)
    self:SetZOrder(100)
    --self:SetBackColor(GetRandomColour())

    count = 0
    for key, value in pairs(SkillList) do
        if value ~= "" then 
            local skillBox = SkillBox(key - 1, self, value:GetCooldown(), value:GetSkillInfo():GetName(), value:GetSkillInfo():GetIconImageID(), value:GetCooldown())
            if SkillEvents[value] == nil then 
                SkillEvents[value] = {}
            end
            SkillEvents[value][#SkillEvents[value] + 1] = skillBox
            --[[
            value.ResetTimeChanged = function(sender, args)
                skillBox:SkillUsed(value:GetResetTime() - Turbine.Engine.GetGameTime())
            end
            --]]
            local currentCooldown = value:GetResetTime() - Turbine.Engine.GetGameTime()
            if currentCooldown > 0 then
                skillBox:SetCooldown(currentCooldown)
            end
        end
            count = count + 1
    end

    self.moveBox = MoveBox(self, width, height, name)
    
    self.ToggleMove = function()
        self.moveBox:ToggleMove()
        self:SetZOrder(100)
    end

    self.GetSkillName = function()
        local nameList = {}
        for key, value in pairs(SkillList) do
            if value ~= "" then            
                nameList[key] = value:GetSkillInfo():GetName()
            else
                nameList[key] = ""
            end
        end
        return nameList
    end

    self.GetBarName = function()
        return(name)
    end

end

SkillBox = class(Turbine.UI.Window)
function SkillBox:Constructor(index, parent, cooldown, name, icon, baseCD)
    Turbine.UI.Window.Constructor(self)
    self:SetParent(parent)
    self:SetPosition(35 * ScaleX * index, 0)
    self:SetSize(32 * ScaleX, 32 * ScaleY)
    --self:SetBackColor(GetRandomColour())
    self:SetVisible(true)
    self:SetMouseVisible(false)

    self.parent = parent
    self.name = name
    self.icon = icon
    self.baseCD = baseCD
    self.cdThreshold = Settings.SkilloverlayCDThreshold
    self.SkillPopups = Settings.SkillbarPopups

    self.countdownLabel = Turbine.UI.Label()
    self.countdownLabel:SetSize(32 * ScaleX, 32 * ScaleY)
    self.countdownLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.countdownLabel:SetVisible(true)
    self.countdownLabel:SetParent(self)
    self.countdownLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.countdownLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.countdownLabel:SetOutlineColor(OutlineColor)
    self.countdownLabel:SetMultiline(false)
    self.countdownLabel:SetMouseVisible(false)
    self.countdownLabel:SetText("")

    self.CurrentCooldown = -1
    self.Countdown = cooldown
    
    local colorThreshold = cooldown / 8
    self.decimalThreshold = 3

    self.bigCooldown = cooldown >= 300
    self.oldCooldown = cooldown
end

function SkillBox:SkillUsed(countdown)
    self:SetCooldown(countdown)
    self.oldCooldown = countdown
    self.parent:SetZOrder(100)
end

function SkillBox:SetCooldown(value)
    if value < 0 then
        if self.SkillPopups and self.baseCD >= self.cdThreshold and self:IsVisible() then 
            SkillPopups:Message(self.name, self.icon) 
        end
        self:SetVisible(false)
        Updater:UnSubscribe(self)
        return
    end
    self.CurrentCooldown = value
    self.countdownLabel:SetForeColor(Turbine.UI.Color(1, 1, 1))
    self.countdownLabel:SetText(math.ceil(value))
    self:SetVisible(true)
    --self:SetWantsUpdates(true)
    Updater:Subscribe(self)
end

function SkillBox:ExecuteUpdate(delta)
    self.CurrentCooldown = self.CurrentCooldown - delta
    if self.oldCooldown - self.CurrentCooldown > 0.05 then
        if self.CurrentCooldown < self.decimalThreshold and self.CurrentCooldown < 100 and not(self.bigCooldown) then
            self.countdownLabel:SetText(Round(self.CurrentCooldown, 1))
        elseif self.CurrentCooldown < 120 then
            self.countdownLabel:SetText(Round(self.CurrentCooldown, 0))
        else
            self.countdownLabel:SetText(Round(self.CurrentCooldown / 60, 0) .. "m")
        end
        self.oldCooldown = self.CurrentCooldown
    end

    if self.CurrentCooldown < 0 then
        --self:SetWantsUpdates(false)
        if self.SkillPopups and self.baseCD >= self.cdThreshold and self:IsVisible() then 
            SkillPopups:Message(self.name, self.icon) 
        end
        self:SetVisible(false)
        Updater:UnSubscribe(self)
    --elseif self.CurrentCooldown < colorThreshold and not(bigCooldown) then
    --    self.countdownLabel:SetForeColor(Turbine.UI.Color(1, 0, 0))
    end
end


SkillEvents = {}

function CreateSkillBarFromSave()
    local skills = {}
    local tskills = Player:GetTrainedSkills()
    for i = 1, Player:GetTrainedSkills():GetCount(), 1 do
        local item = tskills:GetItem(i)--:GetSkillInfo()
        local name = item:GetSkillInfo():GetName() 
        local description = item:GetSkillInfo():GetDescription()

        if (not(RealSkill(description))and string.len(description) > 0 and item:GetSkillInfo():GetType() ~= 1) then
            skills[name] = item
        end
    end
    local CompleteSkillList = {}
    for key, value in pairs(SkillBars) do
        local SkillBarWithActualSkills = {}
        for index, skillName in pairs(value) do
            local skill = skills[skillName]
            if skill ~= nil then 
                SkillBarWithActualSkills[index] = skill
            else
                SkillBarWithActualSkills[index] = ""
            end
        end
        CompleteSkillList[key] = SkillBarWithActualSkills
    end

    CreateSkillBars(CompleteSkillList)

    local UsedSkillEvents = {}

    for key, value in pairs(SkillEvents) do
        UsedSkillEvents[key] = true
    end

    for key, value in pairs(SkillWindowSkill) do
        UsedSkillEvents[key] = true
    end

    for key, value in pairs(UsedSkillEvents) do
        key.ResetTimeChanged = function(sender, args)
            local SkillBarItem = SkillEvents[key]
            if SkillBarItem ~= nil then
                local cd = key:GetResetTime() - Turbine.Engine.GetGameTime()
                for _, box in pairs(SkillBarItem) do
                    box:SkillUsed(cd)
                end
            end

            local SkillWindowItem = SkillWindowSkill[key]
            if SkillWindowItem ~= nil then
                SkillWindowItem:DoSkill(key)
            end
        end
    end

    --table.insert( ActiveSkillBars, SkillBar(SkillBars, name))

end

SkillPopupWindow = class(Turbine.UI.Control)
function SkillPopupWindow:Constructor()
    self.width = 300
    self.height = 100
    local x = Settings.SKPX
    local y = Settings.SKPY
    self.Alerts = {}
    self.resort = false

    local MaxItems = 5

    self.count = 0

    self.messageDuration = 5

    Turbine.UI.Window.Constructor(self);
    self:SetSize(self.width, self.height);
    self:SetPosition(x,y);
    self:SetZOrder(1);

    self:SetWantsKeyEvents(false)
    self:SetMouseVisible(false)
    self:SetVisible(true)
    --self:SetBackColor(GetRandomColour())
    --self:SetWantsUpdates(true)
    Updater:Subscribe(self)

    self.ReUpdateAlertPositions = function()

        local counter = 0
        for _,v in spairs(self.Alerts, function(t,a,b) return t[b][2] > t[a][2] end) do
            v[1]:SetPosition(0, MaxItems * (Settings.ABaseHeight) - (counter * Settings.ABaseHeight)) 
            counter = counter + 1
        end

        self.resort = false
    end

    self.moveBox = MoveBox(self, self.width, self.height, "Skill Popups")

end

function SkillPopupWindow:Message(message, icon)

    local Popup = Turbine.UI.Window()
    Popup:SetParent(self)
    Popup:SetVisible(true)
    Popup:SetSize(self.width, 20)
    --Popup:SetBackColor(GetRandomColour())

    local iconLabel = Turbine.UI.Label()
    iconLabel:SetParent(Popup)
    iconLabel:SetSize(32, 32)
    iconLabel:SetStretchMode(1)
    iconLabel:SetBackground(icon)
    iconLabel:SetSize(20, 20)

    local messageLabel = Turbine.UI.Label()
    messageLabel:SetParent(Popup)
    messageLabel:SetPosition(20, 0)
    messageLabel:SetSize(self.width- 20, 20)
    messageLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    messageLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
    messageLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    messageLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    messageLabel:SetMarkupEnabled(true)
    messageLabel:SetText("<rgb=#00FF00>" .. message .. "</rgb> is ready!")


    local counter = 0
    if self.count > 0 then
        for key, value in pairs(self.Alerts) do
            value[1]:SetPosition(0, value[1]:GetTop() + 20) 
            --ChatOutput(value[1]:GetTop())
        end
    end
    self.Alerts[#self.Alerts + 1] = {Popup, self.messageDuration}
    --self.resort = true

    self.count = self.count + 1
    --Alerts[5] = Alert(self, 10, "Test", PuddleIconSmall, true)
    --ChatOutput(message)
end

function SkillPopupWindow:ToggleMove()
    self.moveBox:ToggleMove()
end

function SkillPopupWindow:ExecuteUpdate(delta)
    for key, value in pairs(self.Alerts) do
        if value ~= nil then
            value[2] = value[2] - delta
            value[1]:SetOpacity(value[2]/self.messageDuration)
            value[1]:SetPosition(0, self.height - self.height * value[2]/self.messageDuration)
            if value[2] <= 0 then
                value[1]:SetParent(nil)
                self.Alerts[key] = nil
                self.resort = true
                self.count = self.count - 1
            end
        end
    end

    --[[
    if self.resort then
        --self.ReUpdateAlertPositions()
        self.resort = false
    end
    --]]
end

-- Loading data
SkillBars = Turbine.PluginData.Load(Turbine.DataScope.Character, "PrimeSkillBars")
if SkillBars == nil then
    SkillBars = {}
end
--SkillBars = {}
SkillBarsPositions = Turbine.PluginData.Load(Turbine.DataScope.Character, "PrimeSkillBarsPositions")
if SkillBarsPositions == nil then
    SkillBarsPositions = {}
end
ActiveSkillBars = {}