local baseImageID = 0x41007E35;

EffectBox = class(Turbine.UI.Control)
function EffectBox:Constructor(parent, effect, size)
    Turbine.UI.Control.Constructor( self )
    self:SetSize(size, size)
    self:SetParent(parent)

    self.duration = effect:GetDuration() - (Turbine.Engine.GetGameTime() - effect:GetStartTime())

    local iconLabel = Turbine.UI.Lotro.EffectDisplay()
    iconLabel:SetEffect(effect)
    iconLabel:SetParent(self)
    --iconLabel:SetPosition(1,1)
    iconLabel:SetSize(size, size)
    iconLabel:SetMouseVisible(false)
    iconLabel:SetVisible(true)

    self.CountDownLabel = Turbine.UI.Label()
    self.CountDownLabel:SetParent(self)
    self.CountDownLabel:SetSize(size, size)
    self.CountDownLabel:SetMouseVisible(false)
    self.CountDownLabel:SetVisible(true)
    self.CountDownLabel:SetStretchMode(1)
    self.CountDownLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.CountDownLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold18)
    self.CountDownLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.CountDownLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.CountDownLabel:SetMultiline(false)
    self.CountDownLabel:SetZOrder(100)
end

function EffectBox:UpdateText(delta)
    if self.duration > 999999 then return end
    self.duration = self.duration - delta
    self.CountDownLabel:SetStretchMode(nil)
    self.CountDownLabel:SetStretchMode(1)

    if self.duration > 3600 then
        self.CountDownLabel:SetText(math.floor(self.duration /3600) .. "h")
    elseif self.duration > 120 then
        self.CountDownLabel:SetText(math.floor(self.duration / 60) .. "m")
    elseif self.duration >= 0 then
        self.CountDownLabel:SetText(math.floor(self.duration))
    elseif self.duration < 0 then
        self.CountDownLabel:SetText("")
    end
end

function EffectBox:GetValue()
    return self.duration
end