ResourceBar = class( Turbine.UI.Control );
function ResourceBar:Constructor(parent, width, height, boxes)
    Turbine.UI.Control.Constructor( self )

    self:SetSize(width + 2, height)
    self:SetZOrder(100)
    self:SetMouseVisible(false)
    self:SetBackColor(Turbine.UI.Color(0,0,0))
    self:SetParent(parent)
    self:SetPosition(0, 160)

    self.BarDictionary = {}

    self.boxes = boxes

    for i = 1,  self.boxes, 1 do
        self.BarDictionary[i] = ResourceBox(self, (i - 1) * width /  self.boxes, width,  self.boxes)
    end  
end

function ResourceBar:ChangeResource(NewNumber, Colour)
--Turbine.UI.Color(1,0.250,0.250)
    for i = 1, self.boxes, 1 do
        if i <= NewNumber then
            self.BarDictionary[i]:TurnOn(Colour)
        else
            self.BarDictionary[i]:TurnOff()
        end
    end  
end

ResourceBox = class( Turbine.UI.Control );
function ResourceBox:Constructor(parent, x, width, boxes)

    Turbine.UI.Control.Constructor( self )
    self:SetParent(parent)
    self:SetBackColor(Turbine.UI.Color(0,0,0))
    self:SetPosition(x, 0)
    self:SetSize(width /  boxes, 20)
    self:SetMouseVisible(false)

    self.InnerBarBackground = Turbine.UI.Control()
    self.InnerBarBackground:SetParent(self)
    self.InnerBarBackground:SetBackColor(Turbine.UI.Color(0.250,0.250,0.250))
    self.InnerBarBackground:SetPosition(2, 2)
    self.InnerBarBackground:SetSize(width /  boxes, 16)
    self.InnerBarBackground:SetMouseVisible(false)

    self.InnerBar = Turbine.UI.Control()
    self.InnerBar:SetParent(self)
    --self.InnerBar:SetBackColor(Turbine.UI.Color(1,0.250,0.250))
    self.InnerBar:SetPosition(2, 2)
    self.InnerBar:SetSize(width /  boxes - 2, 16)
    self.InnerBar:SetMouseVisible(false)

end

function ResourceBox:TurnOn(Colour)
    self.InnerBar:SetBackColor(Colour)
end

function ResourceBox:TurnOff()
    self.InnerBar:SetBackColor()
end