TargetWindow = class( Turbine.UI.Window)
function TargetWindow:Constructor()
    Turbine.UI.Window.Constructor( self );
	
    --self.layout = Turbine.UI.HorizontalLayout.LeftToRight;

    Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Target, false );
    
    local width = 254
    local height = 160 + 160 + 86

    local vitalWidth = 250
    local vitalHeight = 80
	
	self:SetPosition(Settings.TargetX, Settings.TargetY );
    self:SetSize( width, height);
    self:SetVisible(false)
    self:SetMouseVisible(false)

    self.BuffBoxes = {}
    self.DebuffBoxes = {}

    self.BuffResort = true
    self.DebuffResort = true

    self.EffectPosition = Settings.EffectVersion

    self.oldGameTime = Turbine.Engine.GetGameTime()

    self.Target = nil

    local offset = 20

    
    --[[
	self.nameLabel = Turbine.UI.Label();
	self.nameLabel:SetParent( self );
	self.nameLabel:SetPosition( 60, 3 );
	self.nameLabel:SetSize( 160, 12 );
	self.nameLabel:SetFontStyle( Turbine.UI.FontStyle.Outline );
	self.nameLabel:SetOutlineColor( Turbine.UI.Color( 0, 0, 0 ) );
	self.nameLabel:SetMouseVisible( false );
    --]]
    
	self.vitalsFrame = Turbine.UI.Control();
	self.vitalsFrame:SetParent( self );
	--self.vitalsFrame:SetBackColor( Turbine.UI.Color( 1, 0, 0, 0 ) );
	self.vitalsFrame:SetPosition( 2, 2 );
	self.vitalsFrame:SetSize( width, 86 );	
    self.vitalsFrame:SetMouseVisible( true );	
    self.vitalsFrame:SetPosition(0, offset + 160)
    self.vitalsFrame:SetBackColor(Turbine.UI.Color(0.125,0.125,0.125))
	
	-- Construct the morale bar.
	self.moraleBar = VitalBar(vitalWidth, vitalHeight - 20, true);
    self.moraleBar:SetParent( self.vitalsFrame );
    self.moraleBar:SetPosition(2, 2)
    self.moraleBar:SetColours(Turbine.UI.Color(0.4, 0.5, 0.1), Turbine.UI.Color(0.4, 0.7, 0.1), Turbine.UI.Color(179/255, 0, 224/255), Turbine.UI.Color(1.0, 0.4, 0))
	--self.moraleBar:SetColor( Turbine.UI.Color( 1, 0.1, 1, 0.1 ) );
	--self.moraleBar:SetBuffColor( Turbine.UI.Color( 1, 0.3, 0.7, 1 ) );
	--self.moraleBar:SetDebuffColor( Turbine.UI.Color( 1, 1.0, 0.4, 0 ) );
	--self.moraleBar:SetPosition( 60, 19 );
	self.moraleBar:SetMouseVisible( false );
	--self.moraleBar:SetShowPercentage( true );
    --self.moraleBar:SetHorizontalLayout( Turbine.UI.HorizontalLayout.RightToLeft );
	
    --self.SetText( self.moraleBar, "This is a really bad thing to be doing. I'm passing the wrong type of control..." );

	
    -- Construct the power bar.
	self.powerBar = VitalBar(vitalWidth, vitalHeight - 60, true);
	self.powerBar:SetParent( self.vitalsFrame );
    self.powerBar:SetZOrder( 100 );
    self.powerBar:SetColours(Turbine.UI.Color(0.1, 0.4, 0.4), Turbine.UI.Color(0.1, 0.1, 0.7), Turbine.UI.Color(179/255, 0, 224/255), Turbine.UI.Color(1.0, 0.4, 0))
	--self.powerBar:SetColor( Turbine.UI.Color( 1, 0.1, 0.5, 1 ) );
	self.powerBar:SetPosition( 2, 64 );
    self.powerBar:SetMouseVisible( false );

    self.text = Turbine.UI.Label()
	self.text:SetForeColor( Turbine.UI.Color( 1, 1, 1, 1 ) )
	self.text:SetOutlineColor( Turbine.UI.Color( 1, 0, 0, 0 ) )
	self.text:SetFontStyle( Turbine.UI.FontStyle.Outline )
	self.text:SetFont( Turbine.UI.Lotro.Font.BookAntiquaBold19 )
	self.text:SetTextAlignment( Turbine.UI.ContentAlignment.TopCenter )
	self.text:SetZOrder( 100 )
    self.text:SetParent( self.moraleBar )
    self.text:SetSize(vitalWidth, vitalHeight - 20)
    self.text:SetMouseVisible(false)

    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()

    self.AddTargetInfo = function()
        if self.Target.GetMorale and self.Target:GetMorale() > 0 then
            --self.moraleBar:SetCurrentValueImmediate( 0)
            self.moraleBar:SetCurrentValueImmediate( self.Target:GetMorale() )
            self.moraleBar:SetMaxValue( self.Target:GetMaxMorale() )
            self.moraleBar:SetTempValue(self.Target:GetTemporaryMorale())
            self.moraleBar:SetMaxTempValue(self.Target:GetMaxTemporaryMorale())
            --self.powerBar:SetCurrentValueImmediate( 0 )
            self.powerBar:SetCurrentValueImmediate( self.Target:GetPower() )
            self.powerBar:SetMaxValue( self.Target:GetMaxPower() )

            self.Target.MoraleChanged = function( sender, args )
                if self.Target then
                    self.moraleBar:SetCurrentValue( self.Target:GetMorale() )
                end
            end
            
            self.Target.MaxMoraleChanged = function( sender, args )
                if self.Target then
                    self.moraleBar:SetMaxValue( self.Target:GetMaxMorale() )
                end
            end
            
            self.Target.BaseMaxMoraleChanged = function( sender, args )
                if self.Target then
                    self.moraleBar:SetMaxValue( self.Target:GetMaxMorale() )
                end
            end
        
            self.Target.TemporaryMoraleChanged = function( sender, args )
                if self.Target then
                    self.moraleBar:SetTempValue(self.Target:GetTemporaryMorale())
                end
            end
            
            self.Target.MaxTemporaryMoraleChanged = function( sender, args )
                if self.Target then
                    self.moraleBar:SetMaxTempValue(self.Target:GetMaxTemporaryMorale())
                end
            end
            
            self.Target.PowerChanged = function( sender, args )
                if self.Target and self.Target.GetPower then
                    self.powerBar:SetCurrentValue( self.Target:GetPower() )
                end
            end
            
            self.Target.MaxPowerChanged = function( sender, args )
                if self.Target and self.Target.GetPower then
                    self.powerBar:SetMaxValue( self.Target:GetMaxPower() )
                end
            end
            
            self.Target.BaseMaxPowerChanged = function( sender, args )
                if self.Target and self.Target.GetPower then
                    self.powerBar:SetMaxValue( self.Target:GetMaxPower() )
                end
            end

            self.moraleBar:SetTextVisible(true)
            self.powerBar:SetTextVisible(true)
        else
            self.moraleBar:SetTextVisible(false)
            self.powerBar:SetTextVisible(false)
        end
    end

    self.Update = function()
        if self.Taget and self.Target.GetMorale and self.Target:GetMorale() > 0 then
            self.AddTargetInfo()

            self:SetWantsUpdates(false)
        end
    end

    self.SetupBars = function()
        if self.Target ~= nil then

            self.text:SetVisible(true)
            self.text:SetText(self.Target:GetName())
            --ChatOutput(self.Target:GetName())
            self.AddTargetInfo()
            self:SetWantsUpdates(true)
            self:SetVisible(true)
        else
            self:SetVisible(false)
        end
    end

    self.player.TargetChanged = function()
        self.Target = self.player:GetTarget()
        self.SetupBars()
    end

    self.Target = self.player:GetTarget()
    self.SetupBars()

    self.Moving = false

    self.vitalsFrame.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end
  
    self.vitalsFrame.MouseUp = function()
        self.Moving = false
    end
  
    self.vitalsFrame.MouseMove = function(sender,args)
        if self.Moving then
          local newLeft = self:GetLeft() - (self.MoveX - args.X)
          local newTop = self:GetTop() - (self.MoveY - args.Y)
          self:SetPosition(newLeft,newTop)
        end
    end

    if self.EffectPosition == 1 then

        self.buffBox = Turbine.UI.Control();
        self.buffBox:SetParent( self );
        --self.buffBox:SetBackColor( Turbine.UI.Color( 1, 0, 0, 0 ) );
        self.buffBox:SetPosition( 2, 2 );
        self.buffBox:SetSize( width, 160 );	
        self.buffBox:SetMouseVisible( false );	
        self.buffBox:SetPosition(0, offset + 160 + 86)
        --self.buffBox:SetBackColor(Turbine.UI.Color(0,0,0))

    elseif self.EffectPosition == 2 then

        self.buffBox = Turbine.UI.Window()
        --self.buffBox:SetParent( self );
        self.buffBox:SetVisible(true)
        --self.buffBox:SetBackColor( Turbine.UI.Color( 1, 0, 0, 0 ) );
        self.buffBox:SetPosition( 1300, 2 );
        self.buffBox:SetSize( 400, 160 );	
        self.buffBox:SetMouseVisible( false );	

    end

    self.debuffBox = Turbine.UI.Control();
	self.debuffBox:SetParent( self );
	--self.debuffBox:SetBackColor( Turbine.UI.Color( 1, 0, 0, 0 ) );
	self.debuffBox:SetPosition( 2, 2 );
	self.debuffBox:SetSize( width, 160 );	
    self.debuffBox:SetMouseVisible( false );	
    self.debuffBox:SetPosition(0, 0)
    --self.debuffBox:SetBackColor(Turbine.UI.Color(0,0,0))

    --self:SetWantsUpdates(true)
end