VitalWindow = class( Turbine.UI.Window)
function VitalWindow:Constructor()
    Turbine.UI.Window.Constructor( self );
	
    --self.layout = Turbine.UI.HorizontalLayout.LeftToRight;
    
    local width = 254
    local height = 160 + 160 + 86

    local vitalWidth = 250
    local vitalHeight = 80
	
	self:SetPosition( Settings.FrameX, Settings.FrameY );
    self:SetSize( width, height);
    self:SetVisible(true)
    self:SetMouseVisible(false)

    self.BuffBoxes = {}
    self.DebuffBoxes = {}

    self.BuffResort = true
    self.DebuffResort = true

    self.UpdateCountdown = Settings.ShowCountdown

    self.IconScale = Settings.IconScale
    self.IconSize = 16 * self.IconScale

    self.IconRow = 0
    self.IconRowHeight = 160 - self.IconSize

    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()
    self.ClassAttr = self.player:GetClassAttributes()
    self.ClassType = self.player:GetClass()


    self.EffectPosition = Settings.EffectVersion

    self.oldGameTime = Turbine.Engine.GetGameTime()

    local offset = 0

    if self.ClassType == Turbine.Gameplay.Class.Champion or 
    self.ClassType == Turbine.Gameplay.Class.Hunter or 
    self.ClassType == Turbine.Gameplay.Class.RuneKeeper then
        offset = 20
    end

    
    --[[
	self.nameLabel = Turbine.UI.Label();
	self.nameLabel:SetParent( self );
	self.nameLabel:SetPosition( 60, 3 );
	self.nameLabel:SetSize( 160, 12 );
	self.nameLabel:SetFontStyle( Turbine.UI.FontStyle.Outline );
	self.nameLabel:SetOutlineColor( Turbine.UI.Color( 0, 0, 0 ) );
	self.nameLabel:SetMouseVisible( false );
    --]]
    
	self.vitalsFrame = Turbine.UI.Control();
	self.vitalsFrame:SetParent( self );
	--self.vitalsFrame:SetBackColor( Turbine.UI.Color( 1, 0, 0, 0 ) );
	self.vitalsFrame:SetPosition( 2, 2 );
	self.vitalsFrame:SetSize( width, 86 );	
    self.vitalsFrame:SetMouseVisible( true );	
    self.vitalsFrame:SetPosition(0, offset + 160)
    self.vitalsFrame:SetBackColor(Turbine.UI.Color(0.125,0.125,0.125))

    self.E = Turbine.UI.Lotro.EntityControl()
    self.E:SetParent (self.vitalsFrame)
    self.E:SetVisible (true)
    self.E:SetSize(width, 86)
    self.E:SetEntity(self.player)
	
	-- Construct the morale bar.
	self.moraleBar = VitalBar(vitalWidth, vitalHeight - 20, true);
    self.moraleBar:SetParent( self.vitalsFrame );
    self.moraleBar:SetPosition(2, 2)
    local colour = nil
    if Settings.ColourMode == 1 then 
        colour = ClassColours[self.player:GetClass()]
    elseif Settings.ColourMode == 2 then
        colour = Turbine.UI.Color(0.4, 0.7, 0.1)
    end
    self.moraleBar:SetColours(Turbine.UI.Color(0.375, 0.375, 0.375), colour, Turbine.UI.Color(179/255, 0, 224/255), Turbine.UI.Color(1.0, 0.4, 0))
	--self.moraleBar:SetColor( Turbine.UI.Color( 1, 0.1, 1, 0.1 ) );
	--self.moraleBar:SetBuffColor( Turbine.UI.Color( 1, 0.3, 0.7, 1 ) );
	--self.moraleBar:SetDebuffColor( Turbine.UI.Color( 1, 1.0, 0.4, 0 ) );
	--self.moraleBar:SetPosition( 60, 19 );
	self.moraleBar:SetMouseVisible( false );
	--self.moraleBar:SetShowPercentage( true );
    --self.moraleBar:SetHorizontalLayout( Turbine.UI.HorizontalLayout.RightToLeft );
	
    --self.SetText( self.moraleBar, "This is a really bad thing to be doing. I'm passing the wrong type of control..." );

	
    -- Construct the power bar.
	self.powerBar = VitalBar(vitalWidth, vitalHeight - 60, Settings.ShowPowerNumbers);
	self.powerBar:SetParent( self.vitalsFrame );
    self.powerBar:SetZOrder( 100 );
    if self.ClassType == Turbine.Gameplay.Class.Beorning then
        self.powerBar:SetColours(Turbine.UI.Color(40/255, 0, 0), Turbine.UI.Color(100/255, 0, 0), Turbine.UI.Color(179/255, 0, 224/255), Turbine.UI.Color(1.0, 0.4, 0))
    else
        self.powerBar:SetColours(Turbine.UI.Color(0.1, 0.4, 0.4), Turbine.UI.Color(0.1, 0.1, 0.7), Turbine.UI.Color(179/255, 0, 224/255), Turbine.UI.Color(1.0, 0.4, 0))
    end
	--self.powerBar:SetColor( Turbine.UI.Color( 1, 0.1, 0.5, 1 ) );
	self.powerBar:SetPosition( 2, 64 );
    self.powerBar:SetMouseVisible( false );

    if Settings.ShowName then
        self.text = Turbine.UI.Label()
        self.text:SetForeColor( Turbine.UI.Color( 1, 1, 1, 1 ) )
        self.text:SetOutlineColor( Turbine.UI.Color( 1, 0, 0, 0 ) )
        self.text:SetFontStyle( Turbine.UI.FontStyle.Outline )
        self.text:SetFont( Turbine.UI.Lotro.Font.BookAntiquaBold19 )
        self.text:SetTextAlignment( Turbine.UI.ContentAlignment.TopCenter )
        self.text:SetZOrder( 100 )
        self.text:SetParent( self.moraleBar )
        self.text:SetSize(vitalWidth, vitalHeight - 20)
        self.text:SetMouseVisible(false)
        self.text:SetText(self.player:GetName())
    end

    self.player.MoraleChanged = function( sender, args )
        self.moraleBar:SetCurrentValueImmediate( self.player:GetMorale() )
	end
	
	self.player.MaxMoraleChanged = function( sender, args )
		self.moraleBar:SetMaxValue( self.player:GetMaxMorale() )
	end
	
	self.player.BaseMaxMoraleChanged = function( sender, args )
		self.moraleBar:SetMaxValue( self.player:GetMaxMorale() )
    end

    self.player.TemporaryMoraleChanged = function( sender, args )
		self.moraleBar:SetTempValue(self.player:GetTemporaryMorale())
	end
	
    self.player.MaxTemporaryMoraleChanged = function( sender, args )
        self.moraleBar:SetMaxTempValue(self.player:GetMaxTemporaryMorale())
	end
    
    if self.ClassType == Turbine.Gameplay.Class.Beorning then
        self.ClassAttr.WrathChanged = function()
            self.powerBar:SetCurrentValue( self.ClassAttr:GetWrath() )
        end

        --[[
        self.ClassAttr.FormChanged = function()
            if self.ClassAttr:IsInBearForm() then
                self.vitalsFrame:SetBackColor(Turbine.UI.Color(0,0,1))
            else
                self.vitalsFrame:SetBackColor(Turbine.UI.Color(1, 0, 0))
            end
        end

        if self.ClassAttr:IsInBearForm() then
            self.vitalsFrame:SetBackColor(Turbine.UI.Color(0,0,1))
        else
            self.vitalsFrame:SetBackColor(Turbine.UI.Color(1, 0, 0))
        end
        --]]
    else
        self.player.PowerChanged = function( sender, args )
            self.powerBar:SetCurrentValue( self.player:GetPower() )
        end
        
        self.player.MaxPowerChanged = function( sender, args )
            self.powerBar:SetMaxValue( self.player:GetMaxPower() )
        end
        
        self.player.BaseMaxPowerChanged = function( sender, args )
            self.powerBar:SetMaxValue( self.player:GetMaxPower() )
        end
    end

    self.moraleBar:SetCurrentValue( self.player:GetMorale() )
    self.moraleBar:SetMaxValue( self.player:GetMaxMorale() )
    self.moraleBar:SetMaxValue( self.player:GetMaxMorale() )
    self.moraleBar:SetTempValue(self.player:GetTemporaryMorale())
    self.moraleBar:SetMaxTempValue(self.player:GetMaxTemporaryMorale())

    if self.ClassType == Turbine.Gameplay.Class.Beorning then
        self.powerBar:SetCurrentValue( self.ClassAttr:GetWrath() )
        self.powerBar:SetMaxValue( 100 )
        self.powerBar:SetMaxValue( 100 )
    else
        self.powerBar:SetCurrentValue( self.player:GetPower() )
        self.powerBar:SetMaxValue( self.player:GetMaxPower() )
        self.powerBar:SetMaxValue( self.player:GetMaxPower() )
    end

    self.Moving = false

    self.E.MouseDoubleClick = function(sender,args)
        if self.E.IsControlKeyDown() then
            self.MoveX = args.X
            self.MoveY = args.Y
            self.Moving = true
            self.vitalsFrame:SetBackColor(Turbine.UI.Color(0,1,0))
        end
    end
  
    self.E.MouseUp = function()
        self.Moving = false
        self.vitalsFrame:SetBackColor(Turbine.UI.Color(0.125,0.125,0.125))
    end
  
    self.E.MouseMove = function(sender,args)
        if self.Moving then
            local newLeft = self:GetLeft() - (self.MoveX - args.X)
            local newTop = self:GetTop() - (self.MoveY - args.Y)
            self:SetPosition(newLeft,newTop)
        end
    end

    if self.EffectPosition == 1 then

        self.buffBox = Turbine.UI.Control();
        self.buffBox:SetParent( self );
        --self.buffBox:SetBackColor( Turbine.UI.Color( 1, 0, 0, 0 ) );
        self.buffBox:SetPosition( 2, 2 );
        self.buffBox:SetSize( width, 160 );	
        self.buffBox:SetMouseVisible( false );	
        self.buffBox:SetPosition(0, offset + 160 + 86)
        --self.buffBox:SetBackColor(Turbine.UI.Color(0,0,0))

        self.IconRow = math.ceil(width / self.IconSize)

    elseif self.EffectPosition == 2 then

        self.buffBox = Turbine.UI.Window()
        --self.buffBox:SetParent( self );
        self.buffBox:SetVisible(true)
        --self.buffBox:SetBackColor( Turbine.UI.Color( 1, 0, 0, 0 ) );
        self.buffBox:SetPosition( 1300, 2 );
        self.buffBox:SetSize( 400, 160 );	
        self.buffBox:SetMouseVisible( false );	

        self.IconRow = math.floor(400 / self.IconSize)

    end

    self.debuffBox = Turbine.UI.Control();
	self.debuffBox:SetParent( self );
	--self.debuffBox:SetBackColor( Turbine.UI.Color( 1, 0, 0, 0 ) );
	self.debuffBox:SetPosition( 2, 2 );
	self.debuffBox:SetSize( width, 160 );	
    self.debuffBox:SetMouseVisible( false );	
    self.debuffBox:SetPosition(0, 0)
    --self.debuffBox:SetBackColor(Turbine.UI.Color(0,0,0))

    -- Effects
    local effectList = self.player:GetEffects()

    for i = 1, effectList:GetCount(), 1 do
        local effect =  effectList:Get(i)

        if effect:IsDebuff() then
            self.DebuffBoxes[effect:GetID()] = EffectBox(self.debuffBox, effect, self.IconSize)
        else
            self.BuffBoxes[effect:GetID()] = EffectBox(self.buffBox, effect, self.IconSize)
        end
    end 

    self.player:GetEffects().EffectRemoved = function(sender, args)
        if args.Effect then 
            local ID = args.Effect:GetID()
            if self.BuffBoxes[ID] then 
                self.BuffBoxes[ID]:SetVisible(false) 
                self.BuffBoxes[ID]:SetParent(nil) 
                self.BuffBoxes[ID] = nil
                self.BuffResort = true
            end
            if self.DebuffBoxes[ID] then 
                self.DebuffBoxes[ID]:SetVisible(false)
                self.DebuffBoxes[ID]:SetParent(nil)  
                self.DebuffBoxes[ID] = nil
                self.DebuffResort = true
            end
        end
    end

    self.player:GetEffects().EffectAdded = function(sender, args)
        local effect = self.player:GetEffects():Get(args.Index)
        if effect:IsDebuff() then
            self.DebuffBoxes[effect:GetID()] = EffectBox(self.debuffBox, effect, self.IconSize)
            self.DebuffResort = true
        else
            self.BuffBoxes[effect:GetID()] = EffectBox(self.buffBox, effect, self.IconSize)
            self.BuffResort = true
        end
    end

    self.Update = function()
        local currentGameTime = Turbine.Engine.GetGameTime()
        if currentGameTime == self.oldGameTime then
            return(true)
        end
        local delta = currentGameTime - self.oldGameTime

        if self.UpdateCountdown then
            for key, value in pairs(self.DebuffBoxes) do
                value:UpdateText(delta)
                --[[
                if value:GetValue() < 0 then
                    value:SetVisible(false) 
                    value:SetParent(nil) 
                    self.DebuffBoxes[key] = nil
                    self.DebuffResort = true
                end
                --]]
            end

            for key, value in pairs(self.BuffBoxes) do
                value:UpdateText(delta)
                --[[
                if value:GetValue() < 0 then
                    value:SetVisible(false) 
                    value:SetParent(nil) 
                    self.BuffBoxes[key] = nil
                    self.BuffResort = true
                end
                --]]
            end
        end

        if self.BuffResort or self.DebuffResort then self.ResortList() end

        self.oldGameTime = currentGameTime
    end

    self.ResortList = function()
        if self.BuffResort then
            if self.EffectPosition == 1 then
                local counter = 0
                for _,v in spairs(self.BuffBoxes, function(t,a,b) return t[b]:GetValue() < t[a]:GetValue() end) do
                    v:SetPosition((counter % self.IconRow) * self.IconSize, math.floor(counter / self.IconRow) * self.IconSize)
                    counter = counter + 1
                end
            elseif self.EffectPosition == 2 then
                local counter = 0
                for _,v in spairs(self.BuffBoxes, function(t,a,b) return t[b]:GetValue() < t[a]:GetValue() end) do
                    v:SetPosition(400 - self.IconSize - (counter % self.IconRow) * self.IconSize, math.floor(counter / self.IconRow) * self.IconSize) 
                    counter = counter + 1	
                end
            end
            self.BuffResort = false
        end

        if self.DebuffResort then
            local counter = 0
            for _,v in spairs(self.DebuffBoxes, function(t,a,b) return t[b]:GetValue() > t[a]:GetValue() end) do
                v:SetPosition((counter % self.IconRow) * self.IconSize, self.IconRowHeight - math.floor(counter / self.IconRow) * self.IconSize) 
                counter = counter + 1
            end
            self.DebuffResort = false
        end
    end

    self:ResortList()
    self:SetWantsUpdates(true)

    -- Resources
    self.RBar = nil

    if self.ClassType == Turbine.Gameplay.Class.Champion then
        self.RBar = ResourceBar(self, 252, 20, 5)

        self.ClassAttr.FervorChanged = function()
            self.RBar:ChangeResource(self.ClassAttr:GetFervor(), Turbine.UI.Color(153/255,0,0))
        end
        self.RBar:ChangeResource(self.ClassAttr:GetFervor(), Turbine.UI.Color(153/255,0,0))

    elseif self.ClassType == Turbine.Gameplay.Class.Hunter then
        self.RBar = ResourceBar(self, 252, 20, 5)

        self.ClassAttr.FocusChanged = function()
            self.RBar:ChangeResource(self.ClassAttr:GetFocus(), Turbine.UI.Color(153/255,0,0))
        end
        self.RBar:ChangeResource(self.ClassAttr:GetFocus(), Turbine.UI.Color(153/255,0,0))

    elseif self.ClassType == Turbine.Gameplay.Class.RuneKeeper then
        self.RBar = ResourceBar(self, 252, 20, 9)

        self.ClassAttr.AttunementChanged = function()
            local Attunement = self.ClassAttr:GetAttunement()
            if Attunement > 10 then
                self.RBar:ChangeResource(math.abs( Attunement - 10), Turbine.UI.Color(0,102/255,0))
            else
                self.RBar:ChangeResource(math.abs( Attunement - 10), Turbine.UI.Color(153/255,0,0))
            end
        end
        local Attunement = self.ClassAttr:GetAttunement()
        if Attunement > 10 then
            self.RBar:ChangeResource(math.abs( Attunement - 10), Turbine.UI.Color(0,102/255,0))
        else
            self.RBar:ChangeResource(math.abs( Attunement - 10), Turbine.UI.Color(153/255,0,0))
        end
    end
end